//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Seeprom.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//@Serial EEPROM AT24C256 z肵Ă
//
//  2011/09/09 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************
#include		<avr/io.h>
#include		<compat/twi.h>

#include		"AVR_ATmega644_Geiger.h"
#include		"Mega_Twi.h"
#include		"Timer.h"
#include		"Utility.h"
#include		"LCD.h"

#include		"Seeprom.h"

#define AT24C255_ID		0xA0	// SEEPROM AT24C256 Device Identifier
//#define AT24C256_ADDR	0x0e	// SEEPROM AT24C256 Device Address(A2:H, A1:H, A0:H)
#define AT24C256_ADDR	0x06	// Â^Cv AT24C256 foCXAhXQ̎̕AA2:L̎͂ Device Address(A2:L, A1:H, A0:H)

//***************************
// Seeprom Initial
// VAddoqnl̏ݒ
//***************************
void	seep_init(void)
{
		twi_init();
}

//***************************
// Seeprom PoCgf[^̓ǂݏo
//   seep_addr: VAddoqnl̃AhX
//   seep_data: ǂݏoVAddoqnlf[^鏊
//  ߂l  0: ɏI
//          1:ُŏI
//  AT24C255_ID		0xA0
//  AT24C256_ADDR	0x07
//  TW_READ			1
//  TW_WRITE		0
//***************************
unsigned char	seep_read_1(unsigned int seep_addr, unsigned char *seep_data)
{
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏo
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏo
	unsigned char	r;

	twi_init();
	seep_addr &= 0x7fff;										// RQoCgȂ̂łOWOOOȏ̃AhX͗L蓾Ȃ
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

//	disp_lcd_G( 0,7,(unsigned char *)"twi_start");		// \
	r = twi_start(AT24C255_ID, AT24C256_ADDR, TW_WRITE);		// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_START_TW_WRITE;
		return(r);
	}
//	disp_lcd_G( 0,7,(unsigned char *)"twi_write1");		// \
	r = twi_write(data_adr_1st);								// TWI  AhX
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_WRITE;
		return(r);
	}
//	disp_lcd_G( 0,7,(unsigned char *)"twi_write2");		// \
	r = twi_write(data_adr_2nd);								// TWI  AhX
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	r = twi_start(AT24C255_ID, AT24C256_ADDR, TW_READ);			// TWI Jn foCXhcƃfoCXAhXƂqd`c
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_START_TW_READ;
		return(r);
	}
	r = twi_read(seep_data, NACK);								// TWI ǂݏo
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_READ;
		return(r);
	}
	twi_stop();

	return(r);
}

//***************************
// Seeprom WoCgf[^̓ǂݏo
//   seep_addr: VAddoqnl̃AhX
//   seep_data: ǂݏoVAddoqnlf[^鏊iWoCgj
//  ߂l Ȃ
//***************************
void	seep_read_8(unsigned int seep_addr, void *vseep_data)
{
	unsigned char	*seep_data;
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏo
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏo
	unsigned char	i;

	twi_init();
	seep_data = (unsigned char *)vseep_data;
	seep_addr &= 0x7fff;										// RQoCgȂ̂łOWOOOȏ̃AhX͗L蓾Ȃ
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

	twi_start(AT24C255_ID, AT24C256_ADDR, TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	twi_write(data_adr_1st);									// TWI  AhX
	twi_write(data_adr_2nd);									// TWI  AhX
	twi_stop();

	twi_start(AT24C255_ID, AT24C256_ADDR, TW_READ);				// TWI Jn foCXhcƃfoCXAhXƂqd`c
	for(i=0;i<7;i++){
		twi_read(seep_data+i, ACK);								// TWI ǂݏo
	}
	twi_read(seep_data+7, NACK);								// TWI ǂݏo
	twi_stop();

}

//***************************
// Seeprom USoCgf[^̓ǂݏo
//   seep_addr: VAddoqnl̃AhX
//   seep_data: ǂݏoVAddoqnlf[^鏊iUSoCgj
//  ߂l Ȃ
//***************************
void	seep_read_64(unsigned int seep_addr, void *vseep_data)
{
	unsigned char	*seep_data;
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏo
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏo
	unsigned char	i;

	twi_init();
	seep_data = (unsigned char *)vseep_data;
	seep_addr &= 0x7fff;										// RQoCgȂ̂łOWOOOȏ̃AhX͗L蓾Ȃ
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);

	twi_start(AT24C255_ID, AT24C256_ADDR, TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	twi_write(data_adr_1st);									// TWI  AhX
	twi_write(data_adr_2nd);									// TWI  AhX
	twi_stop();

	twi_start(AT24C255_ID, AT24C256_ADDR, TW_READ);				// TWI Jn foCXhcƃfoCXAhXƂqd`c
	for(i=0;i<63;i++){
		twi_read(seep_data+i, ACK);								// TWI ǂݏo
	}
	twi_read(seep_data+63, NACK);								// TWI ǂݏo
	twi_stop();

}

//***************************
// Seeprom PoCgf[^̏
//   seep_addr: VAddoqnl̃AhX
//   seep_data: VAddoqnl̏ރf[^
//  ߂l  0: ɏI
//          1:ُŏI
//***************************
unsigned char	seep_write_1(unsigned int seep_addr, unsigned char *seep_data)
{

	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏoiʁj
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏoiʁj
	unsigned char	r;

	twi_init();
	seep_addr &= 0x7fff;										// RQoCgȂ̂łOWOOOȏ̃AhX͗L蓾Ȃ
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);


	r = twi_start(AT24C255_ID, AT24C256_ADDR, TW_WRITE);		// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_START_TW_WRITE;
		return(r);
	}
	r = twi_write(data_adr_1st);								// TWI  AhX
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(data_adr_2nd);								// TWI  AhX
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_WRITE;
		return(r);
	}
	r = twi_write(*seep_data);									// TWI  f[^
	if(r != 0){													// G[̎
		r = SEEP_ERR_TWI_WRITE;
		return(r);
	}
	twi_stop();

	delay_ms(10);												// Wait 10mS

	return(r);
}

//***************************
// Seeprom WoCgf[^̏
//   seep_addr: VAddoqnl̃AhXiWoCg؂ARrbgOj
//   seep_data: VAddoqnl̏ރf[^̗L鏊iWoCgj
//  ߂l Ȃ
//***************************
void	seep_write_8(unsigned int seep_addr, void *vseep_data)
{

	unsigned char	*seep_data;
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏoiʁj
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏoiʁj
	unsigned char	i;

	twi_init();
	seep_data = (unsigned char *)vseep_data;
	seep_addr &= 0x7ff8;										// RQoCgȂ̂łOWOOOȏ̃AhX͗L蓾ȂBWoCgŋ؂AhXɂ
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);


	twi_start(AT24C255_ID, AT24C256_ADDR, TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	twi_write(data_adr_1st);									// TWI  AhX
	twi_write(data_adr_2nd);									// TWI  AhX

	for(i=0;i<8;i++,seep_data++){
		twi_write(*seep_data);									// TWI  f[^
	}
	twi_stop();

	delay_ms(10);												// Wait 10mS
}

//***************************
// Seeprom USoCgf[^̏
//   seep_addr: VAddoqnl̃AhXiUSoCg؂AUoCgOj
//   seep_data: VAddoqnl̏ރf[^̗L鏊iUSoCgj
//  ߂l Ȃ
//***************************
void	seep_write_64(unsigned int seep_addr, void *vseep_data)
{
	unsigned char	*seep_data;
	unsigned char	data_adr_1st;								// rddoqnl̃AhX̍ŏɏoiʁj
	unsigned char	data_adr_2nd;								// rddoqnl̃AhX̂QԖڂɏoiʁj
	unsigned char	i;

	twi_init();
	seep_data = (unsigned char *)vseep_data;
	seep_addr &= 0x7fc0;										// RQoCgȂ̂łOWOOOȏ̃AhX͗L蓾ȂBUSoCgŋ؂AhXɂ
	data_adr_1st = (unsigned char)((seep_addr >> 8) & 0xff);
	data_adr_2nd = (unsigned char)(seep_addr & 0xff);


	twi_start(AT24C255_ID, AT24C256_ADDR, TW_WRITE);			// TWI Jn foCXhcƃfoCXAhXƂvqhsd
	twi_write(data_adr_1st);									// TWI  AhX
	twi_write(data_adr_2nd);									// TWI  AhX

	for(i=0;i<64;i++,seep_data++){
		twi_write(*seep_data);									// TWI  f[^
	}
	twi_stop();

	delay_ms(10);												// Wait 10mS
}

// **************************
// *** SEEPROM TEST START ***
// **************************
void	seeprom_test(void)
{
	unsigned char	uc;
	unsigned char	wc = 0x12;


	seep_init();

	for(;;){
		led_on();							// LED ON
		seep_read_1(0x0010,&uc);
		wtod_02x((char *)disp_moji, uc);
		disp_lcd_G( 0,5,disp_moji);			// JEg \
		delay_ms(2000);						// 2000mS Delay
		led_off();							// LED OFF
		seep_write_1(0x0010, &wc);
		wc++;
		delay_ms(2000);						// 2000mS Delay
	}

}
// **************************
// **** SEEPROM TEST END ****
// **************************

