//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Serial.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//  2012/03/28 Modify for All Model  Taishi(Ver 1.11) 
//  2012/03/31 Modify for All Model  Taishi(Ver 1.12) 
//*****************************************
#include			<avr/io.h>
#include			<avr/eeprom.h>
#include			<avr/pgmspace.h>


#include			"AVR_ATmega644_Geiger.h"
#include			"Serial.h"
#include			"Timer.h"
#include			"Ad_conv.h"
#include			"Utility.h"
#include			"LCD.h"
#include			"Comm1.h"
#include			"EEPROM.h"
#include			"Seeprom.h"
#include			"Rtc.h"
#include			"Const_str.h"
#include			"Save_Dt.h"

#include			"Setting.h"

unsigned int		v_ubrr[CODE_BPS_MAX+1] ={			// BPS ɑ΂ enum code_bps Ɠт̕KvL
						BPS_1200,						// taqqO̒l(1200)
						BPS_2400,						// taqqO̒l(2400)
						BPS_4800,						// taqqO̒l(4800)
						BPS_9600,						// taqqO̒l(9600)
						BPS_14400,						// taqqO̒l(14400)
						BPS_19200,						// taqqO̒l(19200)
						BPS_28800,						// taqqO̒l(28800)
						BPS_38400,						// taqqO̒l(38400)
						BPS_57600,						// taqqO̒l(57600)
						BPS_76800,						// taqqO̒l(76800)
						BPS_115200,						// taqqO̒l(115200)
					};

unsigned char		set_bps = CODE_9600;				// ݂̐ݒaorR[h̒l
unsigned char		set_parity = CODE_PARITY_NON;		// ݂̐ݒpeBR[h̒l
unsigned char		set_data_length = CODE_DATA_8;		// ݂̃f[^R[h̒l

unsigned char		save_set_bps;						// Mf[^̐ݒaorR[h̒l
unsigned char		save_set_parity;					// Mf[^̐ݒpeBR[h̒l
unsigned char		save_set_data_length;				// Mf[^̃f[^R[h̒l


//*****************************************
// ^CgAo[WM
//*****************************************
void	tx_title(void)
{
	get_pgm_str(&str_title_1[0]);								// vÖ̕(TITLE1)擾
	uart0_tx_str_crlf("");										// UART TxD String + CR + LF
	tx0_str(&disp_moji[0]);										// UART TxD String

	get_pgm_str(&str_title_2[0]);								// vÖ̕ o[W擾
	uart0_tx_str_crlf((char *)&disp_moji[0]);					// UART TxD String + CR + LF

}
//*****************************************
// vO쐬NM
//*****************************************
void	tx_make_data(void)
{
	get_pgm_str(&str_make_date[0]);								// vÖ̕("Make Date:")擾
	tx0_str(&disp_moji[0]);										// UART TxD String

	tx0_char(' ');
	get_pgm_str(&str_date[0]);									// vÖ̕(N)擾
	tx0_str(&disp_moji[0]);										// UART TxD String

	tx0_char(' ');
	get_pgm_str(&str_time[0]);									// vÖ̕()擾
	uart0_tx_str_crlf((char *)&disp_moji[0]);					// UART TxD String + CR + LF

}
//*****************************************
// ݒWM
//*****************************************
void	tx_setting_value(void)
{
	// HV Moni
	get_pgm_str(&str_hv_moni[0]);								// vÖ̕("HV Moni")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(' ');
	get_pgm_str(&str_span[0]);									// vÖ̕("Span")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(':');
	wtod_5u((char *)disp_moji,hv_hosei_spn);					// Xp␳ Data
	tx0_str(&disp_moji[1]);										// UART TxD String
	tx0_char(',');
	tx0_char(' ');
	get_pgm_str(&str_offset[0]);								// vÖ̕("Offset")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(':');
	wtod_5u((char *)disp_moji,hv_hosei_ofs);					// ItZbg␳ Data
	uart0_tx_str_crlf((char *)&disp_moji[2]);					// UART TxD String + CR + LF

	// HV Volt
	get_pgm_str(&str_hv_volt[0]);								// vÖ̕("HV-VOLT")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(':');
	wtod_5u((char *)disp_moji, hv_target_volt);					// ␳ Data
	uart0_tx_str_crlf((char *)&disp_moji[2]);					// UART TxD String + CR + LF

	// cpm->uSv/h Span
	get_pgm_str(&str_cpm_to_uSv[0]);							// vÖ̕("cpm->uSv")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(' ');
	get_pgm_str(&str_span[0]);									// vÖ̕("Span")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(':');
	wtod_5u((char *)disp_moji,cpm_to_uSv_spn);					// Z Data
	disp_moji[6] = disp_moji[5];
	disp_moji[5] = disp_moji[4];
	disp_moji[4] = '.';
	tx0_str(&disp_moji[1]);										// UART TxD String
	tx0_char(',');
	tx0_char(' ');
	get_pgm_str(&str_offset[0]);								// vÖ̕("Offset")擾
	tx0_str(&disp_moji[0]);										// UART TxD String
	tx0_char(':');
	wtod_5u((char *)disp_moji,cpm_to_uSv_ofs);					// Z Data
	uart0_tx_str_crlf((char *)&disp_moji[2]);					// UART TxD String + CR + LF

}

//*****************************************
// ۑf[^iPԖ͂PԂƁj̑M
// cph: 0=cpm Data, 1=cph Data, 2=cpd Data
//*****************************************
void	transmit_cph_save_data(unsigned char cph)
{
	unsigned int	i;
	unsigned char	uc;
	unsigned long	ul;
	unsigned int	ui;
	unsigned char	saidai;

	tx_title();									// ^CgAo[WM
	tx_make_data();								// vO쐬NM
	tx_setting_value();							// ݒWM
	disp_clear_lcd_G();								// Clear Display
	get_pgm_str(&str_save_data_transmit[0]);		// "Transmit Save Data"
	disp_lcd_G(1,0,disp_moji);						// \
	tx0_str(&disp_moji[0]);							// UART TxD String
	if(cph == 0){									// PԂƃf[^(cpm)̎
		get_pgm_str(&str_cpm[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}else if(cph == 1){								// PԂƃf[^(cph)̎
		get_pgm_str(&str_cph[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}else{											// Pƃf[^(cpd)̎
		get_pgm_str(&str_cpd[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}
	tx0_char(' ');
	uart0_tx_str_crlf((char *)&disp_moji[0]);		// UART TxD String + CR + LF

	wait_sw_off();									// Q̃XCb`Q@܂ŉiv[v

	eeprom_busy_wait();
	if(cph == 0){									// PԂƃf[^(cpm)̎
		uc = cpm_write_pos;							// ̕ۑʒu
		saidai = N_of_EEP_MINUTE_DATA;
	}else if(cph == 1){								// PԖf[^̎
		uc = eeprom_read_byte(&eep_cph_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_HOUR_DATA;
	}else{											// Pf[^̎
		uc = eeprom_read_byte(&eep_cpd_write_pos);	// ̕ۑʒu
		saidai = N_of_EEP_DAY_DATA;
	}
	if(uc == 0xff){									// ۑ
		get_pgm_str(&str_no_data[0]);				// vÖ̕("No Data !!")擾
		disp_lcd_G( 3,1,disp_moji);					// \
		uart0_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String + CR + LF
	
		delay_ms(4000);								// 4000mS Delay

	}else{											// ۑL鎞
		i = 1;
		for(;;){
			if(i == 0){
				get_pgm_str(&str_done[0]);												// vÖ̕("Done")擾
				disp_lcd_G( 8,5,disp_moji);												// \
				delay_ms(2000);															// 2000mS Delay
				break;
			}else{
				for(; ; ){
					uc--;
					if(saidai <= uc){
						uc = (saidai - 1);
					}

					tx0_char('-');
					wtod_05u((char *)(&disp_moji[0]), i);								// ԍ
					tx0_str(&disp_moji[0]);												// UART TxD String
					tx0_char(':');

					eeprom_busy_wait();
					if(cph == 0){														// PԂƃf[^(cpm)̎
						ul = eeprom_read_dword(eep_minute_time_data + uc);				// PԖf[^̎ǂݏo
					}else if(cph == 1){													// PԖf[^(cph)̎
						ul = eeprom_read_dword(eep_hour_time_data + uc);				// PԖf[^̎ǂݏo
					}else{																// Pf[^(cpd)̎
						ul = eeprom_read_dword(eep_day_time_data + uc);					// Pf[^̎ǂݏo
					}
					convert_display_date_time(ul);										// unsigned long ̒l\pɕϊ
					tx0_str(&disp_moji[0]);												// UART TxD String
					tx0_char(',');

					eeprom_busy_wait();
					if(cph == 0){														// PԂƃf[^(cpm)̎
						ul = (unsigned long)eeprom_read_word(eep_minute_data + uc);		// PԖf[^̓ǂݏo
						if(ul == 0xffff){
							ul = 0xffffffff;
						}
					}else if(cph == 1){													// PԖf[^(cph)̎
						ul = eeprom_read_dword(eep_hour_data + uc);						// PԖf[^̓ǂݏo
					}else{																// Pf[^(cpd)̎
						ul = eeprom_read_dword(eep_day_data + uc);						// Pf[^̓ǂݏo
					}
					if(ul == 0xffffffff){
						get_pgm_str(&str_5minus[0]);									// "-----"
						tx0_str(&disp_moji[0]);											// UART TxD String
						tx0_str(&disp_moji[3]);											// UART TxD String
						tx0_char(',');
						uart0_tx_str_crlf((char *)&disp_moji[1]);						// UART TxD String + CR + LF
						i = 0;
						break;
					}else{
						ui = (unsigned short)(ul/10000);
						wtod_7u((char *)disp_moji, ul);									// PԖ͂PԂƂ̃JEg
						tx0_str(&disp_moji[0]);											// UART TxD String
						tx0_char(',');
						if(cph == 0){													// PԂƃf[^(cpm)̎
							get_uSv_at_count(ul, 1);									// rZiPԂ̃JEgɂj
						}else if(cph == 2){
							get_uSv_at_count(ul/(unsigned long)24, 0);					// rZiPԂ̃JEgɂj
						}else{
							get_uSv_at_count(ul, 0);									// rZiPԂ̃JEgɂj
						}
						uart0_tx_str_crlf((char *)&disp_moji[0]);						// UART TxD String + CR + LF
					}
					i++;
					if(saidai < i){
						i = 0;
						break;
					}
				}
			}
		}
	}
}

//*****************************************
// forf[^Lۑf[^̑M
// ssm: 0=NON, 1=cpm Data, 2=cph Data, 3=cpd Data
//*****************************************
static
void	transmit_seep_save_gps_data(unsigned char	ssm )
{
	unsigned int	i;
	char			*cp;

	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[0]);													// UART TxD String"          "
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[0]);													// UART TxD String"          "
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[0]);													// UART TxD String"          "
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[0]);													// UART TxD String"          "
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[1]);													// UART TxD String"         "
	get_pgm_str(&str_dddmmmmmm[0]);											// "dddmm.mmmm"
	tx0_str(&disp_moji[1]);													// UART TxD String"Date"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[7]);													// UART TxD String"   "
	get_pgm_str(&str_dddmmmmmm[0]);											// "dddmm.mmmm"
	uart0_tx_str_crlf((char *)&disp_moji[0]);								// UART TxD String"dddmm.mmmm" + CR + LF

	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[6]);													// UART TxD String"    "
	get_pgm_str(&str_save_data[0]);											// "No       uSv/h"
	disp_moji[2] = 0;
	tx0_str(&disp_moji[0]);													// UART TxD String"No"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[3]);													// UART TxD String"       "
	get_pgm_str(&str_date_moji[0]);											// "Date"
	tx0_str(&disp_moji[0]);													// UART TxD String"Date"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[8]);													// UART TxD String"  "
	get_pgm_str(&str_time_moji[0]);											// "Time"
	tx0_str(&disp_moji[0]);													// UART TxD String"Time"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[7]);													// UART TxD String"   "
	get_pgm_str(&str_count[0]);												// "Count"
	tx0_str(&disp_moji[0]);													// UART TxD String"Count"
	get_pgm_str(&str_save_data[0]);											// "No       uSv/h"
	tx0_str(&disp_moji[8]);													// UART TxD String" uSv/h"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[7]);													// UART TxD String"   "
	get_pgm_str(&str_utc_gmt[0]);											// "UTC(GMT)"
	tx0_str(&disp_moji[0]);													// UART TxD String"UTC(GMT)"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[9]);													// UART TxD String" "
	get_pgm_str(&str_latitude[0]);											// "Latitude(N)"
	tx0_str(&disp_moji[0]);													// UART TxD String"Latitude(N)"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[9]);													// UART TxD String" "
	get_pgm_str(&str_longitude[0]);											// "Longitude(E)"
	tx0_str(&disp_moji[0]);													// UART TxD String"Longitude(E)"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[8]);													// UART TxD String"  "
	get_pgm_str(&str_height[0]);											// "Height"
	tx0_str(&disp_moji[0]);													// UART TxD String"Height"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[7]);													// UART TxD String"   "
	get_pgm_str(&str_gioid[0]);												// "Gioid"
	tx0_str(&disp_moji[0]);													// UART TxD String"Gioid"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[8]);													// UART TxD String"  "
	get_pgm_str(&str_valid[0]);												// "Valid"
	uart0_tx_str_crlf((char *)&disp_moji[0]);								// UART TxD String"VAlid" + CR + LF


	for(i=seep_write_pos;0 < i;i--){
		seep_read_64((i-1) * 64, (void *)(&lsep_dt[0]));
		if((lsep_dt[0] == 0xffffffff)&&(lsep_dt[1] == 0xffffffff)){			// f[^QO̎iۑf[^Ij
			get_pgm_str(&str_end[0]);										// vÖ̕("END")擾
			uart0_tx_str_crlf((char *)&disp_moji[0]);						// UART TxD String + CR + LF
			break;
		}else{
			disp_moji[0] = ' ';
			wtod_5u((char *)(&disp_moji[1]), seep_write_pos - i );			// ԍ
			if(disp_moji[4] == ' '){
				disp_moji[4] = '-';
			}else if(disp_moji[3] == ' '){
				disp_moji[3] = '-';
			}else if(disp_moji[2] == ' '){
				disp_moji[2] = '-';
			}else if(disp_moji[1] == ' '){
				disp_moji[1] = '-';
			}else{
				disp_moji[0] = '-';
			}
			tx0_str(&disp_moji[0]);											// UART TxD String
			tx0_char(':');
			convert_display_date_time(lsep_dt[1]);							// unsigned long ̒l\pɕϊ
			tx0_str(&disp_moji[0]);											// UART TxD String
			tx0_char(',');
		}
		if(lsep_dt[0] == 0xffffffff){
			get_pgm_str(&str_5minus[0]);									// "-----"
			tx0_str(&disp_moji[0]);											// UART TxD String
			tx0_str(&disp_moji[3]);											// UART TxD String
			tx0_char(',');
			uart0_tx_str_crlf((char *)&disp_moji[1]);						// UART TxD String + CR + LF
			get_pgm_str(&str_end[0]);										// vÖ̕("END")擾
			uart0_tx_str_crlf((char *)&disp_moji[0]);						// UART TxD String + CR + LF
			break;
		}else{
			wtod_7u((char *)disp_moji, lsep_dt[0]);							// PԖ͂PԂƂ̃JEg
			tx0_str(&disp_moji[0]);											// UART TxD String
			tx0_char(',');
			tx0_char(' ');
			disp_moji[0] = 0;
			if(ssm == 1){													// PԂƃf[^(cpm)̎
				get_uSv_at_count(lsep_dt[0], 1);							// rZiPԂ̃JEgɂj
			}else if(ssm == 2){
				get_uSv_at_count(lsep_dt[0], 0);							// rZiPԂ̃JEgɂj
			}else if(ssm == 3){
				get_uSv_at_count(lsep_dt[0]/(unsigned long)24, 0);			// rZiPԂ̃JEgɂj
			}
			tx0_str(disp_moji);												// UART TxD String
		}
		tx0_char(',');
		cp = (char *)(&lsep_dt[2]);											// GPS Data
		uart0_tx_str_crlf(cp);												// UART TxD String + CR + LF

		wtod_5u((char *)disp_moji,seep_write_pos - i+1);
		disp_lcd_G(5, 5, &disp_moji[2]);									// display Dot Matrix LCD
	}
}
//*****************************************
// forf[^ۑf[^̑M
// ssm: 0=NON, 1=cpm Data, 2=cph Data, 3=cpd Data
//*****************************************
static
void	transmit_seep_save_nogps_data(unsigned char	ssm )
{
	unsigned int	i;

	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[6]);													// UART TxD String"    "
	get_pgm_str(&str_save_data[0]);											// "No       uSv/h"
	disp_moji[2] = 0;
	tx0_str(&disp_moji[0]);													// UART TxD String"No"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[3]);													// UART TxD String"       "
	get_pgm_str(&str_date_moji[0]);											// "Date"
	tx0_str(&disp_moji[0]);													// UART TxD String"Date"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[8]);													// UART TxD String"  "
	get_pgm_str(&str_time_moji[0]);											// "Time"
	tx0_str(&disp_moji[0]);													// UART TxD String"Time"
	get_pgm_str(&str_space10[0]);											// "          "
	tx0_str(&disp_moji[7]);													// UART TxD String"   "
	get_pgm_str(&str_count[0]);												// "Count"
	tx0_str(&disp_moji[0]);													// UART TxD String"Count"
	get_pgm_str(&str_save_data[0]);											// "No       uSv/h"
	uart0_tx_str_crlf((char *)&disp_moji[8]);								// UART TxD String" uSv/h" + CR + LF

	for(i=seep_write_pos;0 < i;i--){
		seep_read_8((i-1) * 8, (void *)(&lsep_dt[0]));
		if((lsep_dt[0] == 0xffffffff)&&(lsep_dt[1] == 0xffffffff)){			// f[^QO̎iۑf[^Ij
			get_pgm_str(&str_end[0]);										// vÖ̕("END")擾
			uart0_tx_str_crlf((char *)&disp_moji[0]);						// UART TxD String + CR + LF
			break;
		}else{
			disp_moji[0] = ' ';
			wtod_5u((char *)(&disp_moji[1]), seep_write_pos - i );			// ԍ
			if(disp_moji[4] == ' '){
				disp_moji[4] = '-';
			}else if(disp_moji[3] == ' '){
				disp_moji[3] = '-';
			}else if(disp_moji[2] == ' '){
				disp_moji[2] = '-';
			}else if(disp_moji[1] == ' '){
				disp_moji[1] = '-';
			}else{
				disp_moji[0] = '-';
			}
			tx0_str(&disp_moji[0]);											// UART TxD String
			tx0_char(':');
			convert_display_date_time(lsep_dt[1]);							// unsigned long ̒l\pɕϊ
			tx0_str(&disp_moji[0]);											// UART TxD String
			tx0_char(',');
		}
		if(lsep_dt[0] == 0xffffffff){
			get_pgm_str(&str_5minus[0]);									// "-----"
			tx0_str(&disp_moji[0]);											// UART TxD String
			tx0_str(&disp_moji[3]);											// UART TxD String
			tx0_char(',');
			uart0_tx_str_crlf((char *)&disp_moji[1]);						// UART TxD String + CR + LF
			get_pgm_str(&str_end[0]);										// vÖ̕("END")擾
			uart0_tx_str_crlf((char *)&disp_moji[0]);						// UART TxD String + CR + LF
			break;
		}else{
			wtod_7u((char *)disp_moji, lsep_dt[0]);							// PԖ͂PԂƂ̃JEg
			tx0_str(&disp_moji[0]);											// UART TxD String
			tx0_char(',');
			tx0_char(' ');
			disp_moji[0] = 0;
			if(ssm == 1){													// PԂƃf[^(cpm)̎
				get_uSv_at_count(lsep_dt[0], 1);							// rZiPԂ̃JEgɂj
			}else if(ssm == 2){
				get_uSv_at_count(lsep_dt[0], 0);							// rZiPԂ̃JEgɂj
			}else if(ssm == 3){
				get_uSv_at_count(lsep_dt[0]/(unsigned long)24, 0);			// rZiPԂ̃JEgɂj
			}
			uart0_tx_str_crlf((char *)&disp_moji[0]);						// UART TxD String + CR + LF
		}
		wtod_5u((char *)disp_moji,seep_write_pos - i+1);
		disp_lcd_G(5, 5, &disp_moji[2]);									// display Dot Matrix LCD
	}
}

//*****************************************
// rddoqnlۑf[^̑M
//*****************************************
void	transmit_seep_save_data(void)
{
	unsigned char	ssm;
	unsigned char	gpe;

	tx_title();										// ^CgAo[WM
	tx_make_data();									// vO쐬NM
	tx_setting_value();								// ݒWM
	disp_clear_lcd_G();								// Clear Display
	get_pgm_str(&str_transmit_seep_data[0]);		// "Transmit Seep Data"
	disp_lcd_G(1,0,disp_moji);						// \
	tx0_str(&disp_moji[0]);							// UART TxD String

	ssm = read_seep_save_mode();					// rddoqnlf[^ۑ[hrddoqnlǂݏo
	if(ssm == 1){									// PԂƃf[^(cpm)̎
		get_pgm_str(&str_cpm[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}else if(ssm == 2){								// PԂƃf[^(cph)̎
		get_pgm_str(&str_cph[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}else if(ssm == 3){								// Pƃf[^(cpd)̎
		get_pgm_str(&str_cpd[0]);					// ̎擾
		disp_lcd_G(5,0,disp_moji);					// \
	}else{
		ssm = 0;
	}
	tx0_char(' ');
	uart0_tx_str_crlf((char *)&disp_moji[0]);		// UART TxD String + CR + LF

	get_pgm_str(&str_gps_data[0]);					// "GPS Data"
	disp_lcd_G(1,1,disp_moji);						// \
	tx0_str(&disp_moji[0]);							// UART TxD String
	gpe = read_seep_gps_enable();					// rddoqnlf[^for[hrddoqnlǂݏo
	if(gpe == 1){									// Enable
		get_pgm_str(&str_buz_enable[0]);			// "Buzzer Enable"
	}else{
		get_pgm_str(&str_buz_disable[0]);			// "Buzzer Disable"
	}
	disp_lcd_G(10,1,&disp_moji[7]);					// \
	uart0_tx_str_crlf((char *)&disp_moji[6]);		// UART TxD String + CR + LF

	wait_sw_off();									// Q̃XCb`Q@܂ŉiv[v

	if(ssm == 0){									// ۑȂ[h̎
		get_pgm_str(&str_no_data[0]);				// "Non Data !!"
		disp_lcd_G(3,1,disp_moji);					// \
		uart0_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String + CR + LF
		delay_ms(4000);								// 4000mS Delay
	}else{
		if(seep_write_pos == 0){						// ۑ
			get_pgm_str(&str_no_data[0]);				// vÖ̕("No Data !!")擾
			disp_lcd_G( 3,1,disp_moji);					// \
			uart0_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String + CR + LF
		}else{											// ۑL鎞
			if(gpe == 1){								// forf[^t̎
				transmit_seep_save_gps_data(ssm);		// forf[^Lۑf[^̑M
			}else{
				transmit_seep_save_nogps_data(ssm);		// forf[^ۑf[^̑M
			}
			get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
			disp_lcd_G(5, 5, &disp_moji[0]);		// display Dot Matrix LCD
			get_pgm_str(&str_done[0]);				// vÖ̕("Done")擾
			disp_lcd_G(5, 5, &disp_moji[0]);		// display Dot Matrix LCD
			delay_ms(2000);							// 2000mS Delay
		}
	}
}
