//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Serial.h
//  wb_[t@C
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//  2012/03/28 Modify for All Model  Taishi(Ver 1.11) 
//*****************************************

//#define	UART_BAISOKU	1										// t`qs̃{[[gpNbN{ݒɂ

#if		CPU_CLOCK == 20								// 20MHz
  // Xtal:20MHz
  #define	CLOCK			200000000				// NbN:20MHziPO{̒lj
#else
  #if	CPU_CLOCK == 18								// 18.432MHz
    // Xtal:18.432MHz
    #define	CLOCK			184320000				// NbN:18.432MHziPO{̒lj
  #else
    #if	CPU_CLOCK == 16								// 16MHz
	  // Xtal:16MHz
	  #define	CLOCK		160000000				// NbN:16MHziPO{̒lj
    #else
	    // Xtal:8MHz								// 8MHz
	    #define	CLOCK		80000000				// NbN:8MHziPO{̒lj
    #endif
  #endif
#endif

#define	BIT_RATE1200		1200								// rbg|g:1200
#define	BIT_RATE2400		2400								// rbg|g:2400
#define	BIT_RATE4800		4800								// rbg|g:4800
#define	BIT_RATE9600		9600								// rbg|g:9600
#define	BIT_RATE14400		14400								// rbg|g:14400
#define	BIT_RATE19200		19200								// rbg|g:19200
#define	BIT_RATE28800		28800								// rbg|g:28800
#define	BIT_RATE38400		38400								// rbg|g:38400
#define	BIT_RATE57600		57600								// rbg|g:57600
#define	BIT_RATE76800		76800								// rbg|g:76800
#define	BIT_RATE115200		115200								// rbg|g:115200

enum code_bps {													// aor
		CODE_1200=0,											// BPS_1200̏ꏊ
		CODE_2400,												// BPS_2400̏ꏊ
		CODE_4800,												// BPS_4800̏ꏊ
		CODE_9600,												// BPS_9600̏ꏊ
		CODE_14400,												// BPS_14400̏ꏊ
		CODE_19200,												// BPS_19200̏ꏊ
		CODE_28800,												// BPS_28800̏ꏊ
		CODE_38400,												// BPS_38400̏ꏊ
		CODE_57600,												// BPS_57600̏ꏊ
		CODE_76800,												// BPS_76800̏ꏊ
		CODE_115200,											// BPS_115200̏ꏊ

		CODE_BPS_MAX											// BPS ͈͊O
	};
enum code_parity {												// peB
		CODE_PARITY_NON = 0,									// peB̏ꏊ
		CODE_PARITY_EVN,										// eB̏ꏊ
		CODE_PARITY_ODD,										// peB̏ꏊ

		CODE_PARITY_MAX											// peB͈͊O
	};
enum code_data_length {											// f[^
		CODE_DATA_8 = 0,										// Wrbgf[^̏ꏊ
		CODE_DATA_7,											// Vrbgf[^̏ꏊ

		CODE_DATA_MAX											// f[^ ͈͊O
	};

// t`qs̐ݒl

#ifdef	UART_BAISOKU											// t`qs̃{[[gpNbN{ݒɂ
// aori{j
#define	BPS_1200		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE1200)+5)/10 - 1 )		// taqqO̒l(1200)
#define	BPS_2400		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE2400)+5)/10 - 1 )		// taqqO̒l(2400)
#define	BPS_4800		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE4800)+5)/10 - 1 )		// taqqO̒l(4800)
#define	BPS_9600		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE9600)+5)/10 - 1)		// taqqO̒l(9600)
#define	BPS_14400		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE14400)+5)/10 - 1)		// taqqO̒l(14400)
#define	BPS_19200		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE19200)+5)/10 - 1)		// taqqO̒l(19200)
#define	BPS_28800		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE28800)+5)/10 - 1)		// taqqO̒l(28800)
#define	BPS_38400		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE38400)+5)/10 - 1)		// taqqO̒l(38400)
#define	BPS_57600		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE57600)+5)/10 - 1)		// taqqO̒l(57600)
#define	BPS_76800		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE76800)+5)/10 - 1)		// taqqO̒l(76800)
#define	BPS_115200		(unsigned int)( (((long)CLOCK/(long)8/(long)BIT_RATE115200)+5)/10 - 1)		// taqqO̒l(115200)

#else

// aor
#define	BPS_1200		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE1200)+5)/10 - 1 )		// taqqO̒l(1200)
#define	BPS_2400		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE2400)+5)/10 - 1 )		// taqqO̒l(2400)
#define	BPS_4800		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE4800)+5)/10 - 1 )		// taqqO̒l(4800)
#define	BPS_9600		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE9600)+5)/10 - 1)		// taqqO̒l(9600)
#define	BPS_14400		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE14400)+5)/10 - 1)		// taqqO̒l(14400)
#define	BPS_19200		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE19200)+5)/10 - 1)		// taqqO̒l(19200)
#define	BPS_28800		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE28800)+5)/10 - 1)		// taqqO̒l(28800)
#define	BPS_38400		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE38400)+5)/10 - 1)		// taqqO̒l(38400)
#define	BPS_57600		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE57600)+5)/10 - 1)		// taqqO̒l(57600)
#define	BPS_76800		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE76800)+5)/10 - 1)		// taqqO̒l(76800)
#define	BPS_115200		(unsigned int)( (((long)CLOCK/(long)16/(long)BIT_RATE115200)+5)/10 - 1)		// taqqO̒l(115200)
#endif

extern	unsigned int	v_ubrr[CODE_BPS_MAX+1];					// BPS ɑ΂ enum code_bps Ɠт̕KvL


extern	unsigned char		set_bps;							// ݂̐ݒaorR[h̒l
extern	unsigned char		set_parity;							// ݂̐ݒpeBR[h̒l
extern	unsigned char		set_data_length;					// ݂̃f[^R[h̒l
extern	unsigned char		save_set_bps;						// Mf[^̐ݒaorR[h̒l
extern	unsigned char		save_set_parity;					// Mf[^̐ݒpeBR[h̒l
extern	unsigned char		save_set_data_length;				// Mf[^̃f[^R[h̒l

extern	void	tx_title(void);									// ^CgAo[WM
extern	void	tx_make_data(void);								// vO쐬NM
extern	void	tx_setting_value(void);							// ݒWM
extern	void	transmit_cph_save_data(unsigned char cph);		// ۑf[^iPԖ͂PԂƁj̑M
extern	void	transmit_seep_save_data(void);					// rddoqnlۑf[^̑M
