//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Setting.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//  2012/03/28 Modify for All Model  Taishi(Ver 1.11) 
//  2012/03/31 Modify for All Model  Taishi(Ver 1.12) 
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>
#include	<avr/pgmspace.h>

#include	"AVR_ATmega644_Geiger.h"
#include	"Utility.h"
#include	"Serial.h"
#include	"LCD.h"
#include	"Display.h"
#include	"Const_str.h"
#include	"Timer.h"
#include	"Ad_conv.h"
#include	"EEPROM.h"
#include	"Rtc.h"
#include	"Save_Dt.h"

#include	"Setting.h"


//*****************************************
// rddoqnlɕۑ郂[h̕ۑ
//   [h(0:, 1:cpm, 2:cph, 3:cpd)
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
static
void	save_seep_save_mode(void)
{
	unsigned char	i;

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		eeprom_write_byte(&eep_seep_save_mode[i], seep_save_mode);		// 
	}
	eeprom_busy_wait();
}
//*****************************************
// rddoqnlɕۑfor[h̕ۑ
//   [h(0:, 1:L)
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
static
void	save_seep_gps_enable(void)
{
	unsigned char	i;

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		eeprom_write_byte(&eep_seep_gps_enable[i], seep_gps_enable);		// 
	}
	eeprom_busy_wait();
}
//*****************************************
// obNCg[h̕ۑ
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
static
void	save_back_light_mode(void)
{
	unsigned char	i;

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		eeprom_write_byte(&eep_back_light_mode[i], back_light_mode);		// 
	}
	eeprom_busy_wait();
}
//*****************************************
// uU[nm^nee̕ۑ
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
static
void	save_buz_on_off(void)
{
	unsigned char	i;

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		eeprom_write_byte(&eep_buz_on[i], buz_on);		// 
	}
}
//*****************************************
// pXkdcnm^nee̕ۑ
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
static
void	save_pulse_led_on_off(void)
{
	unsigned char	i;

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		eeprom_write_byte(&eep_pulse_led_on[i], pulse_led_on);		// 
	}
}
//*****************************************
// rddoqnlɕۑ郂[h̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	load_seep_save_mode(void)
{
	unsigned char	i;
	unsigned char	uc;
	unsigned char	uc_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		uc_dim[i] = eeprom_read_byte(&eep_seep_save_mode[i]);		// rddoqnlɕۑ郂[h
	}
	uc = tasuuketu_uc(uc_dim[0], uc_dim[1], uc_dim[2], 0);			// 

	for(i=0;i<3;i++){
		if(uc != uc_dim[i]){
			eeprom_busy_wait();
			eeprom_write_byte(&eep_seep_save_mode[i], uc);			// lɂ
		}
	}

	if(uc == 1){
		seep_save_mode = 1;
	}else if(uc == 2){
		seep_save_mode = 2;
	}else if(uc == 3){
		seep_save_mode = 3;
	}else{
		seep_save_mode = 0;
	}
}
//*****************************************
// rddoqnlɕۑfor[h̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	load_seep_gps_enable(void)
{
	unsigned char	i;
	unsigned char	uc;
	unsigned char	uc_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		uc_dim[i] = eeprom_read_byte(&eep_seep_gps_enable[i]);		// rddoqnlɕۑ郂[h
	}
	uc = tasuuketu_uc(uc_dim[0], uc_dim[1], uc_dim[2], 0);			// 

	for(i=0;i<3;i++){
		if(uc != uc_dim[i]){
			eeprom_busy_wait();
			eeprom_write_byte(&eep_seep_gps_enable[i], uc);			// lɂ
		}
	}

	if(uc == 1){
		seep_gps_enable = 1;
	}else{
		seep_gps_enable = 0;
	}
}
//*****************************************
// obNCg[h̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	load_back_light_mode(void)
{
	unsigned char	i;
	unsigned char	uc;
	unsigned char	uc_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		uc_dim[i] = eeprom_read_byte(&eep_back_light_mode[i]);			// obNCg[h
	}
	uc = tasuuketu_uc(uc_dim[0], uc_dim[1], uc_dim[2], 1);				// 

	for(i=0;i<3;i++){
		if(uc != uc_dim[i]){
			eeprom_busy_wait();
			eeprom_write_byte(&eep_back_light_mode[i], uc);			// lɂ
		}
	}

	if(uc == 1){
		back_light_mode = 1;
	}else if(uc == 2){
		back_light_mode = 2;
	}else{
		back_light_mode = 0;
	}
}
//*****************************************
// uU[nm^nee̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	load_buz_on_off(void)
{
	unsigned char	i;
	unsigned char	uc;
	unsigned char	uc_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		uc_dim[i] = eeprom_read_byte(&eep_buz_on[i]);				// uU[gp
	}
	uc = tasuuketu_uc(uc_dim[0], uc_dim[1], uc_dim[2], 0);				// 

	for(i=0;i<3;i++){
		if(uc != uc_dim[i]){
			eeprom_busy_wait();
			eeprom_write_byte(&eep_buz_on[i], uc);			// lɂ
		}
	}

	if(uc == 1){
		buz_on = 1;
	}else{
		buz_on = 0;
	}
}
//*****************************************
// pXkdc nm^nee̓ǂݏo
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	load_pulse_led_on_off(void)
{
	unsigned char	i;
	unsigned char	uc;
	unsigned char	uc_dim[3];

	for(i=0;i<3;i++){
		eeprom_busy_wait();
		uc_dim[i] = eeprom_read_byte(&eep_pulse_led_on[i]);				// pXkdcgp
	}
	uc = tasuuketu_uc(uc_dim[0], uc_dim[1], uc_dim[2], 0);				// 

	for(i=0;i<3;i++){
		if(uc != uc_dim[i]){
			eeprom_busy_wait();
			eeprom_write_byte(&eep_pulse_led_on[i], uc);			// lɂ
		}
	}

	if(uc == 1){
		pulse_led_on = 1;
	}else{
		pulse_led_on = 0;
	}
}

//*****************************************
// rddoqnlۑ[h̕ύXƃf[^̑S
//   ssm: x̕ۑ[h
//*****************************************
void	clear_seep_data_change(unsigned char ssm)
{
	unsigned char	keta=0;								//1:Go, 0:Cansel
	unsigned char	kesu=1;

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_seep_save_off[0]);					// vÖ̕("Seep Save")擾
	disp_moji[9] = 0;									// ͍폜\
	disp_lcd_G( 0,0,disp_moji);							// \
	get_pgm_str(&str_mode_change[0]);					// vÖ̕("Mode Change")擾
	disp_lcd_G( 2,1,disp_moji);							// \
	get_pgm_str(&str_and[0]);							// vÖ̕("and")擾
	disp_lcd_G( 7,2,disp_moji);							// \
	get_pgm_str(&str_data_delete[0]);					// vÖ̕("Data Delete ?")擾
	disp_lcd_G( 2,3,disp_moji);							// \


	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){								// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;
			kesu ^= 1;										// ␳l̓_
			if(kesu == 0){									// _ł̓_̎
				get_pgm_str(&str_cancel[0]);				// vÖ̕("Cancel")擾
				disp_lcd_G( 1,5,&disp_moji[0]);				// \
				get_pgm_str(&str_go[0]);					// vÖ̕("Go")擾
				disp_lcd_G( 1,6,&disp_moji[0]);				// \

			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd_G(1,5, &disp_moji[4]);			// Cancel ̏ꏊ
				}else{
					disp_lcd_G(1,6, &disp_moji[8]);			// Go ̏ꏊ
				}
			}
		}
		get_sw();											//@XCb`Ԃ
		if(sw[2] != 0){										// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){						// XCb`
				keta++;
				if(2 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){				// EXCb`
				if(keta == 1){								// Go
					get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
					disp_lcd_G(1,5, &disp_moji[4]);			// Cancel ̏ꏊ
					get_pgm_str(&str_go[0]);				// vÖ̕("Go")擾
					disp_lcd_G( 1,6,&disp_moji[0]);			// \
					if((ssm != 0)&&(seep_write_pos != 0)){	// x̃[hneeȊOŁ@rddoqnlɕۑf[^L鎞
						delete_seep_all_data();				// rddoqnlf[^̑S
					}
					cli();
					seep_save_mode = ssm;
					save_seep_save_mode();					// rddoqnlɕۑ[h̕ۑ
					sei();									// 荞݉
					get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
					disp_lcd_G(10, 5, &disp_moji[0]);		// display Dot Matrix LCD
					get_pgm_str(&str_done[0]);				// vÖ̕("Done")擾
					disp_lcd_G(10, 5, &disp_moji[0]);		// display Dot Matrix LCD
					delay_ms(2000);							// 2000mS Delay
					break;
				}else if(keta == 0){						// Cansel
					break;
				}
				kesu = 1;
			}
		}
	}

	wait_key_off();											// Q̃XCb`Q@܂ŉiv[v
	cli();
}
//*****************************************
// rddoqnlۑfor[hύXƃf[^̑S
//*****************************************
static
void	clear_seep_gps_change(unsigned char gpe)
{
	unsigned char	keta=0;								//1:Go, 0:Cansel
	unsigned char	kesu=1;

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_gps_data[0]);						// vÖ̕("GPS Data")擾
	disp_lcd_G( 0,0,disp_moji);							// \
	get_pgm_str(&str_buz_enable[0]);					// vÖ̕("Buzzer Enable")擾
	disp_lcd_G( 4,0,&disp_moji[7]);						// \("Enable")
	get_pgm_str(&str_dive[0]);							// vÖ̕("/")擾
	disp_lcd_G(10,0,&disp_moji[0]);						// \
	get_pgm_str(&str_buz_disable[0]);					// vÖ̕("Buzzer Disable")擾
	disp_lcd_G(11,0,&disp_moji[7]);						// \("Disable")
	get_pgm_str(&str_mode_change[0]);					// vÖ̕("Mode Change")擾
	disp_lcd_G( 2,1,disp_moji);							// \
	get_pgm_str(&str_and[0]);							// vÖ̕("and")擾
	disp_lcd_G( 7,2,disp_moji);							// \
	get_pgm_str(&str_data_delete[0]);					// vÖ̕("Data Delete ?")擾
	disp_lcd_G( 2,3,disp_moji);							// \


	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){								// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;
			kesu ^= 1;										// ␳l̓_
			if(kesu == 0){									// _ł̓_̎
				get_pgm_str(&str_cancel[0]);				// vÖ̕("Cancel")擾
				disp_lcd_G( 1,5,&disp_moji[0]);				// \
				get_pgm_str(&str_go[0]);					// vÖ̕("Go")擾
				disp_lcd_G( 1,6,&disp_moji[0]);				// \

			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd_G(1,5, &disp_moji[4]);			// Cancel ̏ꏊ
				}else{
					disp_lcd_G(1,6, &disp_moji[8]);			// Go ̏ꏊ
				}
			}
		}
		get_sw();											//@XCb`Ԃ
		if(sw[2] != 0){										// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){						// XCb`
				keta++;
				if(1 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){				// EXCb`
				if(keta == 1){								// Go
					get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
					disp_lcd_G(1,5, &disp_moji[4]);			// Cancel ̏ꏊ
					get_pgm_str(&str_go[0]);				// vÖ̕("Go")擾
					disp_lcd_G( 1,6,&disp_moji[0]);			// \
					if((seep_save_mode != 0)&&(seep_write_pos != 0)){	// ۑ[hneeȊOŁ@rddoqnlɕۑf[^L鎞
						delete_seep_all_data();				// rddoqnlf[^̑S
					}
					cli();
					seep_gps_enable = gpe;
					save_seep_gps_enable();					// rddoqnlɕۑfor[h̕ۑ
					sei();									// 荞݉
					get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
					disp_lcd_G(10, 5, &disp_moji[0]);		// display Dot Matrix LCD
					get_pgm_str(&str_done[0]);				// vÖ̕("Done")擾
					disp_lcd_G(10, 5, &disp_moji[0]);		// display Dot Matrix LCD
					delay_ms(2000);							// 2000mS Delay
					break;
				}else if(keta == 0){						// Cansel
					break;
				}
				kesu = 1;
			}
		}
	}

	wait_key_off();											// Q̃XCb`Q@܂ŉiv[v
	cli();
}
//*****************************************
// rddoqnlf[^̑S
//     no_cancel 1:LZifn̂݁j 0:LZLibƂf̂Qځj
//*****************************************
void	clear_seep_save_data(unsigned char no_cancel)
{
	unsigned char	keta=0;								//1:Go, 0:Cansel
	unsigned char	kesu=1;

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_seep_save_off[0]);					// vÖ̕("Seep Save")擾
	disp_moji[9] = 0;									// ͍폜\
	disp_lcd_G( 0,0,disp_moji);							// \
	get_pgm_str(&str_data_delete[0]);					// vÖ̕("Data Delete ?")擾
	disp_lcd_G( 2,1,disp_moji);							// \

	if(no_cancel == 1){									// LZȂ̎
		keta = 1;										// J[\fɂ
	}

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){								// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;
			kesu ^= 1;										// ␳l̓_
			if(kesu == 0){									// _ł̓_̎
				if(no_cancel != 1){							// LZL̎
					get_pgm_str(&str_cancel[0]);			// vÖ̕("Cancel")擾
					disp_lcd_G( 1,5,&disp_moji[0]);			// \
				}
				get_pgm_str(&str_go[0]);					// vÖ̕("Go")擾
				disp_lcd_G( 1,6,&disp_moji[0]);				// \

			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd_G(1,5, &disp_moji[4]);			// Cancel ̏ꏊ
				}else{
					disp_lcd_G(1,6, &disp_moji[8]);			// Go ̏ꏊ
				}
			}
		}
		get_sw();											//@XCb`Ԃ
		if(sw[2] != 0){										// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){						// XCb`
				if(no_cancel != 1){							// LZL̎
					keta++;
					if(1 < keta){
						keta = 0;
					}
				}
			}else if((sw[2] & SW_RIGHT) != 0){				// EXCb`
				if(keta == 1){								// Go
					get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
					disp_lcd_G(1,5, &disp_moji[4]);			// Cancel ̏ꏊ
					get_pgm_str(&str_go[0]);				// vÖ̕("Go")擾
					disp_lcd_G( 1,6,&disp_moji[0]);			// \
					delete_seep_all_data();					// rddoqnlf[^̑S
					get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
					disp_lcd_G(10, 5, &disp_moji[0]);		// display Dot Matrix LCD
					get_pgm_str(&str_done[0]);				// vÖ̕("Done")擾
					disp_lcd_G(10, 5, &disp_moji[0]);		// display Dot Matrix LCD
					delay_ms(2000);							// 2000mS Delay
					break;
				}else if(keta == 0){						// Cansel
					break;
				}
				kesu = 1;
			}
		}
	}

	wait_key_off();											// Q̃XCb`Q@܂ŉiv[v
	cli();
}
//*****************************************
// rddoqnlɕۑ郂[h ^^^
//*****************************************
static
void	seep_save_off_cpm_cph_cpd(void)
{
	unsigned char	keta=0;								//0:/cpm/cph/cpd, 1:SAVE&EXIT 2:Delete
	unsigned char	kesu=1;
	unsigned char	ssm;

	ssm = seep_save_mode;
	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_seep_save_off[0]);					// vÖ̕("Seep Save OFF")擾
	disp_moji[9] = 0;									// ͍폜\
	disp_lcd_G( 0,0,disp_moji);							// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){								// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;
			kesu ^= 1;										// ␳l̓_
			if(kesu == 0){									// _ł̓_̎
				if(ssm == 3){					// cpd
					get_pgm_str(&str_seep_save_cpd[0]);		// vÖ̕("Seep Save cpd")擾
				}else if(ssm == 2){				// cph
					get_pgm_str(&str_seep_save_cph[0]);		// vÖ̕("Seep Save cph")擾
				}else if(ssm == 1){				// cpm
					get_pgm_str(&str_seep_save_cpm[0]);		// vÖ̕("Seep Save cpm")擾
				}else{
					get_pgm_str(&str_seep_save_off[0]);		// vÖ̕("Seep Save OFF")擾
				}
				disp_lcd_G( 1,1,&disp_moji[0]);				// \

				get_pgm_str(&str_save_exit[0]);				// vÖ̕("Save&Exit")擾
				disp_lcd_G( 1,2,disp_moji);					// \

				get_pgm_str(&str_seep_delete[0]);			// vÖ̕("Seep Delete")擾
				disp_lcd_G( 1,3,disp_moji);					// \

			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd_G(1,1, &disp_moji[0]);			// ON/AUTO/OFF ̏ꏊ
					disp_lcd_G(11,1, &disp_moji[4]);		// ON/AUTO/OFF ̏ꏊ
				}else if(keta == 2){
					disp_lcd_G(1,3, &disp_moji[0]);			// Delete ̏ꏊ
					disp_lcd_G(11,3, &disp_moji[7]);		// Delete ̏ꏊ
				}else{
					disp_lcd_G(1,2, &disp_moji[0]);			// Save&Exit ̏ꏊ
				}
			}
		}
		get_sw();											//@XCb`Ԃ
		if(sw[2] != 0){										// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){						// XCb`
				keta++;
				if(2 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){				// EXCb`
				if(keta == 0){								// rddoqnlɕۑ̎
					ssm++;
					if(3 < ssm){
						ssm = 0;
					}
				}else if(keta == 1){						// ۑ̎
					if(ssm != seep_save_mode){				// ύXꂽ
						cli();								// 荞ݕs
						clear_seep_data_change(ssm);		// rddoqnlۑ[hύXƃf[^̑S
						sei();								// 荞݉
					}
					break;
				}else if(keta == 2){						// SEEPROM DELETE̎
					cli();									// 荞ݕs
					clear_seep_save_data(0);				// rddoqnlf[^̑S
					sei();									// 荞݉
					break;
				}
				kesu = 1;
			}
		}
	}

	wait_key_off();											// Q̃XCb`Q@܂ŉiv[v
	cli();
}
//*****************************************
// rddoqnlɕۑf[^ɂforf[^t^Ȃ
//*****************************************
static
void	seep_gps_enable_disable(void)
{
	unsigned char	keta=0;								//0:Disable/ Enable, 1:SAVE&EXIT
	unsigned char	kesu=1;
	unsigned char	gpe;

	gpe = seep_gps_enable;
	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_gps_data[0]);						// vÖ̕("GPS Data")擾
	disp_lcd_G( 0,0,disp_moji);							// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){								// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;
			kesu ^= 1;										// ␳l̓_
			if(kesu == 0){									// _ł̓_̎
				if(gpe == 1){								// Enable
					get_pgm_str(&str_buz_enable[0]);		// vÖ̕("Buzzer Enable")擾
				}else{
					get_pgm_str(&str_buz_disable[0]);		// vÖ̕("Buzzer Disable")擾
				}
				disp_lcd_G( 1,1,&disp_moji[6]);				// \i"Enable" "Disable" ̕\j

				get_pgm_str(&str_save_exit[0]);				// vÖ̕("Save&Exit")擾
				disp_lcd_G( 1,2,disp_moji);					// \

			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd_G(1,1, &disp_moji[0]);			// ON/AUTO/OFF ̏ꏊ
				}else{
					disp_lcd_G(1,2, &disp_moji[0]);			// Save&Exit ̏ꏊ
				}
			}
		}
		get_sw();											//@XCb`Ԃ
		if(sw[2] != 0){										// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){						// XCb`
				keta++;
				if(1 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){				// EXCb`
				if(keta == 0){								// obNCg[h̎
					gpe++;
					if(1 < gpe){
						gpe = 0;
					}
				}else if(keta == 1){						// ۑ̎
					if(gpe != seep_gps_enable){				// ύXꂽ
						cli();								// 荞ݕs
						clear_seep_gps_change(gpe);			// rddoqnlۑfor[hύXƃf[^̑S
						sei();								// 荞݉
					}
					break;
				}
				kesu = 1;
			}
		}
	}

	wait_key_off();											// Q̃XCb`Q@܂ŉiv[v
	cli();
}

//*****************************************
// obNCg@nm^`tsn^nee
//*****************************************
static
void	back_light_auto_off(void)
{
	unsigned char	keta=0;								//0:ON/AUTO/OFF, 1:SAVE&EXIT
	unsigned char	kesu=1;

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_back_light_off[0]);				// vÖ̕("Back Light OFF")擾
	disp_moji[10] = 0;									// ͍폜\
	disp_lcd_G( 0,0,disp_moji);							// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){								// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;
			kesu ^= 1;										// ␳l̓_
			if(kesu == 0){									// _ł̓_̎
				if(back_light_mode == 2){					// ON
					get_pgm_str(&str_back_light_on[0]);		// vÖ̕("Back Light ON")擾
				}else if(back_light_mode == 1){				// AUTO
					get_pgm_str(&str_back_light_auto[0]);	// vÖ̕("Back Light AUTO")擾
				}else{
					get_pgm_str(&str_back_light_off[0]);	// vÖ̕("Back Light OFF")擾
				}
				disp_lcd_G( 1,1,&disp_moji[11]);			// \

				get_pgm_str(&str_save_exit[0]);				// vÖ̕("Save&Exit")擾
				disp_lcd_G( 1,2,disp_moji);					// \

			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd_G(1,1, &disp_moji[6]);			// ON/AUTO/OFF ̏ꏊ
				}else{
					disp_lcd_G(1,2, &disp_moji[0]);			// Save&Exit ̏ꏊ
				}
			}
		}
		get_sw();											//@XCb`Ԃ
		if(sw[2] != 0){										// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){						// XCb`
				keta++;
				if(1 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){				// EXCb`
				if(keta == 0){								// obNCg[h̎
					back_light_mode++;
					if(2 < back_light_mode){
						back_light_mode = 0;
					}
				}else if(keta == 1){						// ۑ̎
					cli();									// 荞ݕs
					save_back_light_mode();					// obNCg[h̕ۑ
					sei();									// 荞݉
					break;
				}
				kesu = 1;
			}
		}
	}

	wait_key_off();											// Q̃XCb`Q@܂ŉiv[v
	cli();
}

//*****************************************
// uU[nm^nee
//*****************************************
static
void	buz_ena_dis(void)
{
	unsigned char	keta=0;								//0:ON/OFF, 1:SAVE&EXIT
	unsigned char	kesu=1;

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_buz_disable[0]);					// vÖ̕("Buzzer Disable")擾
	disp_moji[6] = 0;									// ͍폜\
	disp_lcd_G( 0,0,disp_moji);							// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){								// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;
			kesu ^= 1;										// ␳l̓_
			if(kesu == 0){									// _ł̓_̎
				if(buz_on == 1){							// ON
					get_pgm_str(&str_back_light_on[0]);		// vÖ̕("Back Light ON")擾
				}else{
					get_pgm_str(&str_back_light_off[0]);	// vÖ̕("Back Light OFF")擾
				}
				disp_lcd_G( 1,1,&disp_moji[11]);			// \

				get_pgm_str(&str_save_exit[0]);				// vÖ̕("Save&Exit")擾
				disp_lcd_G( 1,2,disp_moji);					// \

			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd_G(1,1, &disp_moji[7]);			// ON/AUTO/OFF ̏ꏊ
				}else{
					disp_lcd_G(1,2, &disp_moji[0]);			// Save&Exit ̏ꏊ
				}
			}
		}
		get_sw();											//@XCb`Ԃ
		if(sw[2] != 0){										// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){						// XCb`
				keta++;
				if(1 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){				// EXCb`
				if(keta == 0){								// obNCg[h̎
					buz_on++;
					if(1 < buz_on){
						buz_on = 0;
					}
				}else if(keta == 1){						// ۑ̎
					cli();									// 荞ݕs
					save_buz_on_off();						// uU[nm^nee̕ۑ
					sei();									// 荞݉
					break;
				}
				kesu = 1;
			}
		}
	}

	wait_key_off();											// Q̃XCb`Q@܂ŉiv[v
	cli();
}

//*****************************************
// pXkdc nm^nee
//*****************************************
static
void	pulse_led_ena_dis(void)
{
	unsigned char	keta=0;								//0:ON/AUTO/OFF, 1:SAVE&EXIT
	unsigned char	kesu=1;

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_pulse_led_disable[0]);				// vÖ̕("Pulse LED Disable")擾
	disp_moji[9] = 0;									// ͍폜\
	disp_lcd_G( 0,0,disp_moji);							// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){								// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;
			kesu ^= 1;										// ␳l̓_
			if(kesu == 0){									// _ł̓_̎
				if(pulse_led_on == 1){							// ON
					get_pgm_str(&str_back_light_on[0]);		// vÖ̕("Back Light ON")擾
				}else{
					get_pgm_str(&str_back_light_off[0]);	// vÖ̕("Back Light OFF")擾
				}
				disp_lcd_G( 1,1,&disp_moji[11]);			// \

				get_pgm_str(&str_save_exit[0]);				// vÖ̕("Save&Exit")擾
				disp_lcd_G( 1,2,disp_moji);					// \

			}else{											// _ł̖ł̎
				get_pgm_str(&str_space10[0]);				// vÖ̕("      ")擾
				if(keta == 0){
					disp_lcd_G(1,1, &disp_moji[7]);			// ON/AUTO/OFF ̏ꏊ
				}else{
					disp_lcd_G(1,2, &disp_moji[0]);			// Save&Exit ̏ꏊ
				}
			}
		}
		get_sw();											//@XCb`Ԃ
		if(sw[2] != 0){										// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){						// XCb`
				keta++;
				if(1 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){				// EXCb`
				if(keta == 0){								// obNCg[h̎
					pulse_led_on++;
					if(1 < pulse_led_on){
						pulse_led_on = 0;
					}
				}else if(keta == 1){						// ۑ̎
					cli();									// 荞ݕs
					save_pulse_led_on_off();				// uU[nm^nee̕ۑ
					sei();									// 荞݉
					break;
				}
				kesu = 1;
			}
		}
	}

	wait_key_off();											// Q̃XCb`Q@܂ŉiv[v
	cli();
}

//*****************************************
// uU[̂nm^neeݒ
//*****************************************
void	proc_buz_enable(void)
{
	if((PIND & (SW_LEFT | SW_RIGHT)) == SW_LEFT){		// PIND7(Right SW) ݂̂nm
		delay_ms(100);									// 100mS Delay
		if((PIND & (SW_LEFT | SW_RIGHT)) == SW_LEFT){	// PIND7(Right SW) ݂̂nm
			back_light_auto_off();						// obNCg@`tsn^nee
			disp_clear_lcd_G();							// Clear Display
			buz_ena_dis();								// uU[nm^nee
			pulse_led_ena_dis();						// pXkdc nm^nee
			disp_clear_lcd_G();							// Clear Display
		}
	}
}

//*****************************************
// guj^Xp␳l
//*****************************************
static
void	proc_set_hv_hosei_spn_valu(void)
{
	unsigned char	keta=0;								//0:1000̌, 1:100̌, 2:10̌, 3:1̌
	unsigned char	kesu=1;
	unsigned char	i;
	unsigned char	lo_hi=0;

	ad67_init();										// A/D 6&7 Initial

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_mon_spn[0]);						// vÖ̕("MON_SPN")擾
	disp_lcd_G( 0,0,disp_moji);							// \

	wtod_05u((char *)disp_moji,hv_hosei_spn);			// Xp␳ Data
	disp_lcd_G( 0,1, &disp_moji[1]);						// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	Timer1_init(1);										// Timer1 Initial
	HV_on();											// High Volt ON

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(lo_hi == 1){
			hv_out = 750;
		}else{
			hv_out = 550;
		}
		set_Timer1_ontime();												// Set Timer1 ON Time

		if(tim_10ms_buz == 0){												// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;
			disp_hv_moni(12,  0);											// guj^l̕\

			kesu ^= 1;														// ␳l̓_
			if(kesu == 0){													// _ł̓_̎
				wtod_05u((char *)disp_moji, hv_hosei_spn);					// Xp␳ Data
				disp_lcd_G( 0,1, &disp_moji[1]);								// \
				get_pgm_str(&str_save_next[0]);								// vÖ̕("Save&Next")擾
				disp_lcd_G( 5,1,disp_moji);									// \
				if(lo_hi == 0){
					get_pgm_str(&str_lo[0]);								// vÖ̕("lo")擾
				}else{
					get_pgm_str(&str_hi[0]);								// vÖ̕("Hi")擾
				}
				disp_lcd_G( 9,0,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta <= 3){
					disp_lcd_G(keta,1, &disp_moji[9]);						// \ ̏ꏊ
				}else if(keta == 4){
					disp_lcd_G (5,1, disp_moji);							// \@Save & Next ̏ꏊ
				}else{
					disp_lcd_G(9,0, &disp_moji[8]);							// \ Hi or Lo ̏ꏊ
				}
			}
		}
		get_sw();															//@XCb`Ԃ
		if(sw[2] != 0){														// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){										// XCb`
				keta++;
				if(5 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){								// EXCb`
				if(keta == 0){												// POOǑ
					if(hv_hosei_spn < 1000){								// POOǑO̎
						hv_hosei_spn += 1000;
					}else{
						hv_hosei_spn %= 1000;
					}
				}else if(keta == 1){										// POǑ
					if( ((hv_hosei_spn % 1000)/100) != 9 ){					// POǑXȊO̎
						hv_hosei_spn += 100;
					}else{
						hv_hosei_spn = ((hv_hosei_spn/1000)*1000)+(hv_hosei_spn % 100);
					}
				}else if(keta == 2){										// PǑ
					if( ((hv_hosei_spn % 100)/10) != 9 ){					// PǑXȊO̎
						hv_hosei_spn += 10;
					}else{
						hv_hosei_spn = ((hv_hosei_spn/100)*100)+(hv_hosei_spn % 10);
					}
				}else if(keta == 3){										// P̌
					if( (hv_hosei_spn % 10) != 9 ){							// P̌XȊO̎
						hv_hosei_spn += 1;
					}else{
						hv_hosei_spn = ((hv_hosei_spn/10)*10);
					}
				}else if(keta == 4){										// Ȉꏊ
					cli();													// 荞ݕs

					for(i=0;i<3;i++){
						eeprom_busy_wait();
						eeprom_write_word(&eep_hv_hosei_spn[i],hv_hosei_spn);	// gu@Xp␳l̕ۑ
					}

					eeprom_busy_wait();
					sei();													// 荞݉
					break;
				}else{														// Hi or Lo ̏ꏊ
					lo_hi ^= 1;
				}
				wtod_05u((char *)disp_moji, hv_hosei_spn);					// Xp␳ Data
				disp_lcd_G( 0,1, &disp_moji[1]);							// \
				kesu = 1;
			}
		}
	}

	HV_off();											// High Volt OFF
	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	cli();
}

//*****************************************
// guj^ItZbg␳l
// \߁@ItZbgl͕ϐɓǂݍ܂ĂƂ
//*****************************************
static
void	proc_set_hv_hosei_ofs_valu(void)
{
	unsigned char	keta=0;								//0:100̌, 1:10̌, 2:1̌, 3:Save & Exit, 4:[Hi] or [Lo]
	unsigned char	kesu=1;
	unsigned char	i;
	unsigned char	lo_hi=0;							// 0:Lo, 1:Hi

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_mon_ofs[0]);						// vÖ̕("MON_OFS")擾
	disp_lcd_G( 0,0,disp_moji);							// \

	wtod_05u((char *)disp_moji,hv_hosei_ofs);			// ItZbg␳ Data
	disp_lcd_G( 0,1, &disp_moji[2]);					// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	Timer1_init(1);										// Timer1 Initial
	HV_on();											// High Volt ON

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp

	while(1){
		if(lo_hi == 1){
			hv_out = 750;
		}else{
			hv_out = 550;
		}
		set_Timer1_ontime();												// Set Timer1 ON Time

		if(tim_10ms_buz == 0){												// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;
			disp_hv_moni(12,  0);											// guj^l̕\

			kesu ^= 1;														// ␳l̓_
			if(kesu == 0){													// _ł̓_̎
				wtod_05u((char *)disp_moji, hv_hosei_ofs);					// Xp␳ Data
				disp_lcd_G( 0,1, &disp_moji[2]);								// \
				get_pgm_str(&str_save_exit[0]);								// vÖ̕("Save&Exit")擾
				disp_lcd_G( 6,1,disp_moji);									// \
				if(lo_hi == 0){
					get_pgm_str(&str_lo[0]);								// vÖ̕("lo")擾
				}else{
					get_pgm_str(&str_hi[0]);								// vÖ̕("Hi")擾
				}
				disp_lcd_G( 9,0,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta <= 2){
					disp_lcd_G(keta,1, &disp_moji[9]);						// \(P̕j
				}else if(keta == 3){
					disp_lcd_G (5,1, disp_moji);							// \(Save & Exit j
				}else if(keta == 4){
					disp_lcd_G (9,0, &disp_moji[8]);						// \([Hi] or [Lo] j
				}
			}
		}
		get_sw();															//@XCb`Ԃ
		if(sw[2] != 0){														// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){										// XCb`
				keta++;
				if(4 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){								// EXCb`
				if(keta == 0){												// POǑ
					if( (hv_hosei_ofs / 100) != 9 ){						// POǑXȊO̎
						hv_hosei_ofs += 100;
					}else{
						hv_hosei_ofs = (hv_hosei_ofs % 100);
					}
				}else if(keta == 1){										// PǑ
					if( ((hv_hosei_ofs % 100)/10) != 9 ){					// PǑXȊO̎
						hv_hosei_ofs += 10;
					}else{
						hv_hosei_ofs = ((hv_hosei_ofs/100)*100)+(hv_hosei_ofs % 10);
					}
				}else if(keta == 2){										// P̌
					if( (hv_hosei_ofs % 10) != 9 ){							// P̌XȊO̎
						hv_hosei_ofs += 1;
					}else{
						hv_hosei_ofs = ((hv_hosei_ofs/10)*10);
					}
				}else if(keta == 3){										// Ȉꏊ
					cli();													// 荞ݕs

					for(i=0;i<3;i++){
						eeprom_busy_wait();
						eeprom_write_word(&eep_hv_hosei_ofs[i],hv_hosei_ofs);	// gu@ItZbg␳l̕ۑ
					}

					eeprom_busy_wait();
					sei();													// 荞݉
					break;
				}else{														// [Hi] or [Lo] ̏ꏊ
					lo_hi ^= 1;
				}
				wtod_05u((char *)disp_moji, hv_hosei_ofs);					// Xp␳ Data
				disp_lcd_G( 0,1, &disp_moji[2]);							// \
				kesu = 1;
			}
		}
	}

	HV_off();																// High Volt OFF
	wait_key_off();															// Q̃XCb`Q@܂ŉiv[v

	cli();
}

//*****************************************
// guo͒l(Volt)
//*****************************************
static
void	proc_set_hv_target_volt(void)
{
	unsigned char	keta=0;								//0:100̌, 1:10̌, 2:1̌
	unsigned char	kesu=1;
	unsigned char	t;

	disp_clear_lcd_G();										// Clear Display
	get_pgm_str(&str_hv_volt[0]);						// vÖ̕("HV-VOLT")擾
	disp_lcd_G( 0,0,disp_moji);							// \
	get_pgm_str(&str_adj[0]);							// vÖ̕("Adj")擾
	disp_lcd_G( 8,0,disp_moji);							// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	Timer1_init(1);										// Timer1 Initial

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){												// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;

			kesu ^= 1;														// ␳l̓_
			if(kesu == 0){													// _ł̓_̎
				wtod_05u((char *)disp_moji, hv_target_volt);				// ␳ Data
				disp_lcd_G( 1,1, &disp_moji[2]);								// \
				get_pgm_str(&str_save_exit[0]);								// vÖ̕("Save&Exit")擾
				disp_lcd_G( 5,1,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta != 3){
					disp_lcd_G(keta+1,1, &disp_moji[9]);					// Xy[X\
				}else{
					disp_lcd_G (5,1, disp_moji);							// \
				}
			}
		}

		get_sw();															//@XCb`Ԃ
		if(sw[2] != 0){														// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){										// XCb`
				keta++;
				if(3 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){								// EXCb`
				if(keta == 0){												// POǑ
					if( (hv_target_volt/100) <= 5 ){						// POǑTȉ̎
						hv_target_volt += 100;
					}else{
						hv_target_volt = (hv_target_volt % 100);
					}
				}else if(keta == 1){										// PǑ
					if( ((hv_target_volt % 100)/10) != 9 ){					// PǑXȊO̎
						hv_target_volt += 10;
					}else{
						hv_target_volt = ((hv_target_volt/100)*100)+(hv_target_volt % 10);
					}
				}else if(keta == 2){										// P̌
					if( (hv_target_volt % 10) != 9 ){						// P̌XȊO̎
						hv_target_volt += 1;
					}else{
						hv_target_volt = ((hv_target_volt/10)*10);
					}
				}else{														// Ȉꏊ
					cli();													// 荞ݕs

					for(t = 0; t < 3; t++){
						eeprom_busy_wait();
						eeprom_write_word(&eep_hv_target_volt[t],hv_target_volt);	// gu@o͒l(Volt)̕ۑ
					}

					eeprom_busy_wait();
					sei();													// 荞݉
					break;
				}
				wtod_05u((char *)disp_moji, hv_target_volt);				// o͓d Data
				disp_lcd_G( 1,1, &disp_moji[2]);							// \
				kesu = 1;
			}
		}
	}

	wait_key_off();															// Q̃XCb`Q@܂ŉiv[v

	cli();
}

//*****************************************
// rZlXp 999.9
//*****************************************
static
void	proc_set_cpm_uSv_span(void)
{
	unsigned char	keta=0;								//0:1000̌, 1:100̌, 2:10̌, 3:1̌
	unsigned char	kesu=1;
	unsigned char	i;

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_cpm_to_uSv[0]);					// vÖ̕("cpm->uSv")擾
	disp_lcd_G( 0,0,disp_moji);							// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G( 8,0,disp_moji);							// \
	get_pgm_str(&str_span[0]);							// vÖ̕("Span")擾
	disp_lcd_G(11,0,disp_moji);							// \

	wtod_05u((char *)disp_moji,cpm_to_uSv_spn);			// Z Data
	disp_moji[6] = disp_moji[5];
	disp_moji[5] = disp_moji[4];
	disp_moji[4] = '.';
	disp_lcd_G( 0,1, &disp_moji[1]);						// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){												// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;

			kesu ^= 1;														// ␳l̓_
			if(kesu == 0){													// _ł̓_̎
				wtod_05u((char *)disp_moji,cpm_to_uSv_spn);					// Z Data
				disp_moji[6] = disp_moji[5];
				disp_moji[5] = disp_moji[4];
				disp_moji[4] = '.';
				disp_lcd_G( 0,1, &disp_moji[1]);								// \
				get_pgm_str(&str_save_next[0]);								// vÖ̕("Save&Next")擾
				disp_lcd_G( 6,1,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta <= 2){
					disp_lcd_G(keta,1, &disp_moji[9]);						// \
				}else if(keta != 4){
					disp_lcd_G(keta+1,1, &disp_moji[9]);					// \
				}else{
					disp_lcd_G (6,1, disp_moji);							// \
				}
			}
		}
		get_sw();															//@XCb`Ԃ
		if(sw[2] != 0){														// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){										// XCb`
				keta++;
				if(4 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){								// EXCb`
				if(keta == 0){												// POOǑ
					if( ((cpm_to_uSv_spn % 10000)/1000) != 9 ){				// POOǑXȊO̎
						cpm_to_uSv_spn += 1000;
					}else{
						cpm_to_uSv_spn %= 1000;
					}
				}else if(keta == 1){										// POǑ
					if( ((cpm_to_uSv_spn % 1000)/100) != 9 ){				// POǑXȊO̎
						cpm_to_uSv_spn += 100;
					}else{
						cpm_to_uSv_spn = ((cpm_to_uSv_spn/1000)*1000)+(cpm_to_uSv_spn % 100);
					}
				}else if(keta == 2){										// PǑ
					if( ((cpm_to_uSv_spn % 100)/10) != 9 ){					// PǑXȊO̎
						cpm_to_uSv_spn += 10;
					}else{
						cpm_to_uSv_spn = ((cpm_to_uSv_spn/100)*100)+(cpm_to_uSv_spn % 10);
					}
				}else if(keta == 3){										// P̌
					if( (cpm_to_uSv_spn % 10) != 9 ){						// P̌XȊO̎
						cpm_to_uSv_spn += 1;
					}else{
						cpm_to_uSv_spn = ((cpm_to_uSv_spn/10)*10);
					}
				}else{														// Ȉꏊ
					if(cpm_to_uSv_spn == 0){
						cpm_to_uSv_spn = 1;
					}
					cli();													// 荞ݕs

					for(i=0;i<3;i++){
						eeprom_busy_wait();
						eeprom_write_word(&eep_cpm_to_uSv_spn[i],cpm_to_uSv_spn);		// rZl̕ۑ
					}

					eeprom_busy_wait();
					sei();													// 荞݉
					break;
				}
				wtod_05u((char *)disp_moji,cpm_to_uSv_spn);					// Z Data
				disp_moji[6] = disp_moji[5];
				disp_moji[5] = disp_moji[4];
				disp_moji[4] = '.';
				disp_lcd_G( 0,1, &disp_moji[1]);							// \
				kesu = 1;
			}
		}
	}

	wait_key_off();															// Q̃XCb`Q@܂ŉiv[v

	cli();
}
//*****************************************
// rZlItZbg 100
//*****************************************
static
void	proc_set_cpm_uSv_ofset(void)
{
	unsigned char	keta=0;								//0:1000̌, 1:100̌, 2:10̌, 3:1̌
	unsigned char	kesu=1;
	unsigned char	i;

	disp_clear_lcd_G();									// Clear Display
	get_pgm_str(&str_cpm_to_uSv[0]);					// vÖ̕("cpm->uSv")擾
	disp_lcd_G( 0,0,disp_moji);							// \
	get_pgm_str(&str_per_h[0]);							// vÖ̕("/h")擾
	disp_lcd_G( 8,0,disp_moji);							// \
	get_pgm_str(&str_offset[0]);						// vÖ̕("Offset")擾
	disp_lcd_G(11,0,disp_moji);							// \

	wtod_05u((char *)disp_moji,cpm_to_uSv_ofs);			// Z Data
	disp_lcd_G( 0,1, &disp_moji[2]);					// \

	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ
	tim_10ms_sw = 0;									// ROro߂Ƃ
	get_sw();											//@XCb`Ԃ

	Timer2_init();										// Timer2 Initial

	sei();												// 荞݉

	wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
	while(1){
		if(tim_10ms_buz == 0){												// TOOr̕\iuU[p^C}[pj
			tim_10ms_buz = 50;

			kesu ^= 1;														// ␳l̓_
			if(kesu == 0){													// _ł̓_̎
				wtod_05u((char *)disp_moji,cpm_to_uSv_ofs);					// Z Data
				disp_lcd_G( 0,1, &disp_moji[2]);								// \
				get_pgm_str(&str_save_exit[0]);								// vÖ̕("Save&Exit")擾
				disp_lcd_G( 6,1,disp_moji);									// \
			}else{															// _ł̖ł̎
				get_pgm_str(&str_space10[0]);								// vÖ̕("      ")擾
				if(keta <= 2){
					disp_lcd_G(keta,1, &disp_moji[9]);						// \
				}else{
					disp_lcd_G (6,1, disp_moji);							// \
				}
			}
		}
		get_sw();															//@XCb`Ԃ
		if(sw[2] != 0){														// ꂽXCb`L鎞
			if((sw[2] & SW_LEFT) != 0){										// XCb`
				keta++;
				if(3 < keta){
					keta = 0;
				}
			}else if((sw[2] & SW_RIGHT) != 0){								// EXCb`
				if(keta == 0){												// POǑ
					if( ((cpm_to_uSv_ofs % 1000)/100) != 1 ){				// POǑPȊO̎
						cpm_to_uSv_ofs += 100;
					}else{
						cpm_to_uSv_ofs %= 100;
					}
				}else if(keta == 1){										// PǑ
					if( ((cpm_to_uSv_ofs % 100)/10) != 9 ){					// PǑXȊO̎
						cpm_to_uSv_ofs += 10;
					}else{
						cpm_to_uSv_ofs = ((cpm_to_uSv_ofs/100)*100)+(cpm_to_uSv_ofs % 10);
					}
				}else if(keta == 2){										// P̌
					if( (cpm_to_uSv_ofs % 10) != 9 ){						// P̌XȊO̎
						cpm_to_uSv_ofs += 1;
					}else{
						cpm_to_uSv_ofs = ((cpm_to_uSv_ofs/10)*10);
					}
				}else{														// Ȉꏊ
					cli();													// 荞ݕs

					for(i=0;i<3;i++){
						eeprom_busy_wait();
						eeprom_write_word(&eep_cpm_to_uSv_ofs[i],cpm_to_uSv_ofs);		// rZl̕ۑ
					}

					eeprom_busy_wait();
					sei();													// 荞݉
					break;
				}
				wtod_05u((char *)disp_moji,cpm_to_uSv_ofs);					// Z Data
				disp_lcd_G( 0,1, &disp_moji[2]);							// \
				kesu = 1;
			}
		}
	}

	wait_key_off();															// Q̃XCb`Q@܂ŉiv[v

	cli();
}
//*****************************************
// guj^␳lAguo͒lArZl̑I
//*****************************************
void	proc_select_hvhosei_hvout_cpmuSv(void)
{
	unsigned char	sel=0;									//0:"HV-Moni", 1:"HV-Out", 2:"cpm->uSv", 3:"Seep_Save", 4:"Time"
	unsigned char	kesu=1;
	unsigned char	r;

	while(1){
		disp_clear_lcd_G();									// Clear Display

		get_pgm_str(&str_hv_moni[0]);						// vÖ̕("HV-Moni")擾
		disp_lcd_G( 0,0,disp_moji);							// \

		get_pgm_str(&str_hv_out[0]);						// vÖ̕("HV-Out")擾
		disp_lcd_G( 0,1,disp_moji);							// \

		get_pgm_str(&str_cpm_to_uSv[0]);					// vÖ̕("cpm->uSv")擾
		disp_lcd_G( 0,2,disp_moji);							// \

		get_pgm_str(&str_seep_save_off[0]);					// vÖ̕("Seep Save OFF")擾
		disp_moji[9]=0;
		disp_lcd_G( 0,3,disp_moji);							// \

		get_pgm_str(&str_gps_data[0]);						// vÖ̕("GPS Data")擾
		disp_lcd_G( 0,4,disp_moji);							// \

		get_pgm_str(&str_d_time[0]);						// vÖ̕("Time")擾
		disp_lcd_G( 0,5,disp_moji);							// \

		tim_10ms_sw = 0;									// ROro߂Ƃ
		get_sw();											//@XCb`Ԃ
		tim_10ms_sw = 0;									// ROro߂Ƃ
		get_sw();											//@XCb`Ԃ
		tim_10ms_sw = 0;									// ROro߂Ƃ
		get_sw();											//@XCb`Ԃ

		Timer2_init();										// Timer2 Initial

		sei();												// 荞݉

		wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

		tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[\Ԋuɗp
		while(1){
			if(tim_10ms_buz == 0){							// TOOr̕\iuU[p^C}[pj
				tim_10ms_buz = 50;

				kesu ^= 1;									// I̓_
				if(kesu == 0){								// _ł̓_̎
					get_pgm_str(&str_hv_moni[0]);			// vÖ̕("HV-Moni")擾
					disp_lcd_G( 0,0,disp_moji);				// \

					get_pgm_str(&str_hv_out[0]);			// vÖ̕("HV-Out")擾
					disp_lcd_G( 0,1,disp_moji);				// \

					get_pgm_str(&str_cpm_to_uSv[0]);		// vÖ̕("cpm->uSv")擾
					disp_lcd_G( 0,2,disp_moji);				// \

					get_pgm_str(&str_seep_save_off[0]);		// vÖ̕("Seep Save OFF")擾
					disp_moji[9]=0;
					disp_lcd_G( 0,3,disp_moji);				// \

					get_pgm_str(&str_gps_data[0]);			// vÖ̕("GPS Data")擾
					disp_lcd_G( 0,4,disp_moji);				// \

					get_pgm_str(&str_d_time[0]);			// vÖ̕("Time")擾
					disp_lcd_G( 0,5,disp_moji);				// \

				}else{										// _ł̖ł̎
					get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
					if(sel == 0){
						disp_lcd_G(0,0, &disp_moji[0]);		// Xy[X\"HV-Moni"
					}else if(sel == 1){
						disp_lcd_G(0,1, &disp_moji[0]);		// Xy[X\"HV-Out"
					}else if(sel == 2){
						disp_lcd_G(0,2, &disp_moji[0]);		// Xy[X\"cpm->uSv"
					}else if(sel == 3){
						disp_lcd_G(0,3, &disp_moji[0]);		// Xy[X\"Seep Save"
					}else if(sel == 4){
						disp_lcd_G(0,4, &disp_moji[0]);		// Xy[X\"GPS Data"
					}else{
						disp_lcd_G(0,5, &disp_moji[0]);		// Xy[X\"Time"
					}
				}
			}
			get_sw();										//@XCb`Ԃ
			if(sw[2] != 0){									// ꂽXCb`L鎞
				if((sw[2] & SW_LEFT) != 0){					// XCb`
					sel++;
					if(5 < sel){
						sel = 0;
					}
				}else if((sw[2] & SW_RIGHT) != 0){			// EXCb`
					get_pgm_str(&str_space10[0]);			// vÖ̕("      ")擾
					if(sel == 0){							// "HV-Moni"
						disp_lcd_G(0,1, &disp_moji[0]);		// Xy[X\"HV-Out"
						disp_lcd_G(0,2, &disp_moji[0]);		// Xy[X\"cpm->uSv"
						disp_lcd_G(0,3, &disp_moji[0]);		// Xy[X\"Seep Save"
						disp_lcd_G(0,4, &disp_moji[0]);		// Xy[X\"GPS Data"
						disp_lcd_G(0,5, &disp_moji[0]);		// Xy[X\"Time"
						get_pgm_str(&str_hv_moni[0]);		// vÖ̕("HV-Moni")擾
						disp_lcd_G( 0,0,disp_moji);			// \
					}else if(sel == 1){						// "HV-Out"
						disp_lcd_G(0,0, &disp_moji[0]);		// Xy[X\"HV-Moni"
						disp_lcd_G(0,2, &disp_moji[0]);		// Xy[X\"cpm->uSv"
						disp_lcd_G(0,3, &disp_moji[0]);		// Xy[X\"Seep Save"
						disp_lcd_G(0,4, &disp_moji[0]);		// Xy[X\"GPS Data"
						disp_lcd_G(0,5, &disp_moji[0]);		// Xy[X\"Time"
						get_pgm_str(&str_hv_out[0]);		// vÖ̕("HV-Out")擾
						disp_lcd_G( 0,1,disp_moji);			// \
					}else if(sel == 2){						// "cpm->uSv"
						disp_lcd_G(0,0, &disp_moji[0]);		// Xy[X\"HV-Moni"
						disp_lcd_G(0,1, &disp_moji[0]);		// Xy[X\"HV-Out"
						disp_lcd_G(0,3, &disp_moji[0]);		// Xy[X\"Seep Save"
						disp_lcd_G(0,4, &disp_moji[0]);		// Xy[X\"GPS Data"
						disp_lcd_G(0,5, &disp_moji[0]);		// Xy[X\"Time"
						get_pgm_str(&str_cpm_to_uSv[0]);	// vÖ̕("cpm->uSv")擾
						disp_lcd_G( 0,2,disp_moji);			// \
					}else if(sel == 3){						// "Seep Save"
						disp_lcd_G(0,0, &disp_moji[0]);		// Xy[X\"HV-Moni"
						disp_lcd_G(0,1, &disp_moji[0]);		// Xy[X\"HV-Out"
						disp_lcd_G(0,2, &disp_moji[0]);		// Xy[X\"cpm->uSv"
						disp_lcd_G(0,4, &disp_moji[0]);		// Xy[X\"GPS Data"
						disp_lcd_G(0,5, &disp_moji[0]);		// Xy[X\"Time"
						get_pgm_str(&str_seep_save_off[0]);	// vÖ̕("Seep Save OFF")擾
						disp_moji[9]=0;
						disp_lcd_G( 0,3,disp_moji);			// \
					}else if(sel == 4){						// "Time"
						disp_lcd_G(0,0, &disp_moji[0]);		// Xy[X\"HV-Moni"
						disp_lcd_G(0,1, &disp_moji[0]);		// Xy[X\"HV-Out"
						disp_lcd_G(0,2, &disp_moji[0]);		// Xy[X\"cpm->uSv"
						disp_lcd_G(0,3, &disp_moji[0]);		// Xy[X\"Seep Save"
						disp_lcd_G(0,5, &disp_moji[0]);		// Xy[X\"Time"
						get_pgm_str(&str_gps_data[0]);		// vÖ̕("GPS Data")擾
						disp_lcd_G( 0,4,disp_moji);			// \
					}else if(sel == 5){						// "Time"
						disp_lcd_G(0,0, &disp_moji[0]);		// Xy[X\"HV-Moni"
						disp_lcd_G(0,1, &disp_moji[0]);		// Xy[X\"HV-Out"
						disp_lcd_G(0,2, &disp_moji[0]);		// Xy[X\"cpm->uSv"
						disp_lcd_G(0,3, &disp_moji[0]);		// Xy[X\"Seep Save"
						get_pgm_str(&str_time[0]);			// vÖ̕("Time")擾
						disp_lcd_G( 0,4,disp_moji);			// \
					}
					break;
				}
			}
		}

		wait_key_off();										// Q̃XCb`Q@܂ŉiv[v

		cli();

		if(sel == 0){										// "HV-Moni"
			proc_set_hv_hosei_spn_valu();					// guj^Xp␳l
			proc_set_hv_hosei_ofs_valu();					// guj^ItZbg␳l
		}else if(sel == 1){									// "HV-Volt"
			proc_set_hv_target_volt();						// guo͒l(Volt)ݒ
		}else if(sel == 2){									// "cpm->uSv"
			proc_set_cpm_uSv_span();
			proc_set_cpm_uSv_ofset();
		}else if(sel == 3){									// "Seep_Save"
			seep_save_off_cpm_cph_cpd();					// rddoqnlɕۑ郂[h
		}else if(sel == 4){									// "Seep_Save"
			seep_gps_enable_disable();						// rddoqnlɕۑf[^ɂforf[^t
		}else if(sel == 5){									// "Time"
			r = proc_set_rtc();								// v킹
			if(r != 0){
				rtc_error(r);
				disp_clear_lcd_G();							// Clear Display
			}
		}
	}
}
