//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Timer.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//  2012/03/31 Modify for All Model  Taishi(Ver 1.12) 
//*****************************************
#include				<avr/interrupt.h>
#include				<avr/io.h>
#include				<avr/pgmspace.h>
#include				<avr/eeprom.h>


#include				"AVR_ATmega644_Geiger.h"
#include				"Serial.h"
#include				"LCD.h"

#include				"Utility.h"
#include				"EEPROM.h"
#include				"Ad_conv.h"
#include				"Timer.h"


unsigned char	tim_1ms;						// 10mSPʂJE^[
unsigned char	tim_10ms;						// PbPʂJE^[
unsigned char	tim_10ms_led;					// kdcpPOrPʃ^C}[
unsigned char	tim_10ms_buz;					// uU[pPOrPʃ^C}[
unsigned char	tim_10ms_sw;					// XCb`͗pPOrPʃ^C}[
unsigned char	tim_10ms_battery;				// obeuNpPOrPʃ^C}[
unsigned char	tim_10ms_battery_zero_now;		// obeuNp̃^C}[OɂȂ

volatile unsigned int	tim_10ms_gps;			// for($GPGAA)f[^Mfp^C}[iPOrPʁj

volatile unsigned int	wait_i;
volatile unsigned int	wait_j;
volatile unsigned char	wait_us;

// ************************************
// Delay 1uS
// t: uS (max 255)
// sb^ł͂Ȃ傫ڂłȂׂ߂lɂȂĂBit=250 ̎j
//  CPU_CLOCK:20MHz --> 300uS (t=250)
//  CPU_CLOCK:18.432MHz --> 258uS (t=250)
//  CPU_CLOCK:16MHz --> 297uS (t=250)
//  CPU_CLOCK:8MHz --> 250uS (t=250)
// ************************************
void delay_1us(unsigned char t)
{
	while(t-- != 0){
#ifdef	_SIMURATION_					// V~[V̎
		;
#else	//_SIMURATION_

#if		CPU_CLOCK == 20								// 20MHz
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
#else	//CPU_CLOCK == 20
  #if	CPU_CLOCK == 18								// 18.432MHz
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
  #else	  //CPU_CLOCK == 18
    #if	CPU_CLOCK == 16								// 16MHz
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
    #else  //CPU_CLOCK == 16						// 8MHz
		wait_us++;				// 1uS Delay
    #endif  //CPU_CLOCK == 16
  #endif  //CPU_CLOCK == 18
#endif	//CPU_CLOCK == 20

#endif	//_SIMURATION_

	}
}
// ************************************
// Delay 2uS
// t: uS (max 255)
// sb^ł͂Ȃ傫ڂłȂׂ߂lɂȂĂBit=250 ̎j
//  CPU_CLOCK:20MHz --> 550uS (t=250)
//  CPU_CLOCK:18.432MHz --> 530uS (t=250)
//  CPU_CLOCK:16MHz --> 532uS (t=250)
//  CPU_CLOCK:8MHz --> 595uS (t=250)
// ************************************
void delay_2us(unsigned char t)
{
	while(t-- != 0){
#ifdef	_SIMURATION_					// V~[V̎
		;
#else	//_SIMURATION_


#if		CPU_CLOCK == 20								// 20MHz
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
#else
  #if	CPU_CLOCK == 18								// 18.432MHz
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
  #else
    #if	CPU_CLOCK == 16								// 16MHz
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
    #else											// 8MHz
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
		wait_us++;				// 1uS Delay
    #endif
  #endif
#endif

#endif	//_SIMURATION_

	}
}
//***************************
// Wait
//  tm : Wait Time(ms) max. 8000
// CPU Clock:20MHz, 18,432MHz, 16MHz, 8MHz
//***************************
void	delay_ms(int tm)
{
	tm *= 2;
	for(wait_i = 0; wait_i < tm; wait_i++){
#if	CPU_CLOCK == 8								// 8MHz
		delay_1us(250);
		delay_1us(250);
#else
		delay_2us(250);
#endif
	}
}

// **********************************************************
// ************************ Timer 2 *************************
// **********************************************************
//*****************************************
// Timer2 Initial
//  1mS 荞݂ɐݒ肷
//*****************************************
void	Timer2_init(void)
{
	TCCR2B = 0;											// Timer Stop
	TCNT2 = 0;											// Timer2 Count Set to ZERO
	TCCR2A = ((1 << WGM21) | (0 << WGM20));				// A Comper Match, Dont Output Timer2 Signal
	OCR2A  = COUNT_1MS;									// 1mS 8MHz/64=125kHz
	TCCR2B = ((1 << CS22) | (0 << CS21) | (0 << CS20));	// Timer Start (8MHz/64= 125kHz, 8uS)
	TIMSK2 |= (1 << OCIE2A);							// A Comper Match Interrupt Enable

	tim_1ms = 0;										// 10mSPʂJE^[
	tim_10ms = 0;										// PbPʂJE^[
	tim_10ms_led = 0;									// kdcpPOrPʃ^C}[
	tim_10ms_buz = 0;									// uU[pPOrPʃ^C}[

}
//***************************
// Timer2 Comper Match A Interrupt
//
//  1mS 
//***************************
ISR	(TIMER2_COMPA_vect)	
{
	tim_1ms--;
	if(tim_1ms == 0){
		tim_1ms = 10;
		tim_10ms++;
		if(100 <= tim_10ms){					// Pbo
			tim_10ms = 0;
			if(tim_1s_back_light != 0){
				tim_1s_back_light--;			// obNCgpPbPʃ^C}[
			}
		}

		if(tim_10ms_led != 0){
			tim_10ms_led--;						// kdcpPOrPʃ^C}[@|P
		}

		if(tim_10ms_buz != 0){
			tim_10ms_buz--;						// uU[pPOrPʃ^C}[@|P
		}

		if(tim_10ms_sw != 0){
			tim_10ms_sw--;
		}

		if(tim_10ms_gps != 0){					// for($GPGAA)f[^Mfp^C}[iPOrPʁj
			tim_10ms_gps--;
		}

		if(tim_10ms_battery != 0){
			tim_10ms_battery--;					// obeuNpPOrPʃ^C}[
			if(tim_10ms_battery == 0){
				tim_10ms_battery_zero_now = 1;
			}
		}

		ad67_set_data();						// A/D 6&7 Set A/D data to Data Buffer
	}
}

// **********************************************************
// ************************ Timer 1 *************************
// **********************************************************

unsigned int	hv_out;
unsigned int	hv_target_volt;
unsigned int	hv_moni;						// g@uiunksPʁj
unsigned int	bat_moni;						// obe@uiODOPuPʁj

//*****************************************
// gu@o͒l̓ǂݏo
// @ei=0 荞ݕs̏ԂŌĂ΂
// @ei=1 荞݉̏ԂŌĂ΂
//*****************************************
void	read_hv_target_volt(unsigned char ei)
{
	unsigned int	i_dim[3];
	unsigned char	t;

	for(t=0;t<3;t++){
		eeprom_busy_wait();
		i_dim[t] = eeprom_read_word(&eep_hv_target_volt[t]);			// gu@o͒l(Volt)
	}

	hv_target_volt = tasuuketu_ui(i_dim[0], i_dim[1], i_dim[2], 400);	// 

	if(599 < hv_target_volt){
		hv_target_volt = HV_DEFAULT;
	}

	cli();																// 荞ݕs
	for(t=0;t<3;t++){
		if(hv_target_volt != i_dim[t]){
			eeprom_busy_wait();
			eeprom_write_word(&eep_hv_target_volt[t],hv_target_volt);	// gu@o͒l(Voltr)̕ۑ
		}
		eeprom_busy_wait();
	}
	if(ei == 1){
		sei();															// 荞݉
	}

}
//*****************************************
// Timer1 Initial
// @ei=0 荞ݕs̏ԂŌĂ΂
// @ei=1 荞݉̏ԂŌĂ΂
//  PD4(OC1B): Pulse Out for High Volt Generator
//*****************************************
void	Timer1_init(unsigned char ei)
{
	TCCR1B = 0x00;														// Timer1 Stop

	DDRD |= (1 << DDD4);												// Port-D Bit4 : Output

	read_hv_target_volt(ei);											// gu@o͒l̓ǂݏo

	hv_out = (unsigned int)(((unsigned long)hv_target_volt * (unsigned long)HV_OUT_400V) / (unsigned long)400);		// o͒lɊZ

	TCNT1 = 0;															// Timer1 Count Set to ZERO
	TCCR1A = ( (1 << COM1B1) | (1 << WGM11) | (1 << WGM10) );			// PWM TOP=OCR1A, OC1B:BOTTOM=H Match=L, 
	TCCR1B = ( (1 << WGM13) | (1 << WGM12) );							// A Comper Match

	//*************************************************
	// **** RC@kgkOWma@PORigp ****
	//*************************************************
	// PfƂPl̕RUuɃfW{iOabcWOOjőA
	// @iRUu RTDQujۂ̕ƂĎgA
	// @Pl[fW{őlɕ|B
	//398V
	OCR1A  = (2000 * 8);												// 8MHz / (2000*8) = 500Hz(2mS)
	OCR1B  = hv_out;													// ON Time ( 1=125nS)

}

//*****************************************
// High Volt ON
// \ timer1  TCCR1BȊÕWX^̓ZbgĂKv
//*****************************************
void	HV_on(void)
{
	TCCR1B |= ( 1 << CS10 );									// Timer1 Prescaler Set  clk-io/1
}
//*****************************************
// High Volt OFF
//*****************************************
void	HV_off(void)
{
	TCCR1B &= ~( (1 << CS12) | (1 << CS11) | (1 << CS10) );		// Timer1 Prescaler Stop
}
//*****************************************
// Set Timer1 ON Time
//*****************************************
void	set_Timer1_ontime(void)
{
	OCR1B  = hv_out;							// ON Time ( 1=125nS : 8MHz)
}

//***************************
// Timer1 Comper Match B Interrupt
//
//  ̏QrԊu
//***************************
ISR	(TIMER1_COMPB_vect)	
{
}


// **********************************************************
// ************************ Timer 0 *************************
// **********************************************************
//*****************************************
// Timer0 Initial
// uU[p
//  PB4(OC0B): Sperker Out(4kHz Signal)
//*****************************************
void	Timer0_init(void)
{
	DDRB |= (1 << DDB4);						// Port-B Bit4 : Output

	TCCR0B = 0;									// Timer Stop
	TCNT0 = 0;									// Timer0 Count Set to ZERO
	TCCR0A = ( (1 << COM0B1) | (0 << COM0B0) | ( 1 << WGM01) | ( 1 << WGM00) );	// ovl(A Comper Match)Aao
	OCR0A  = KHz_4;								// 4kHz(259uS) at 8MHz/64=125kHz
	OCR0B  = OCR0A/2;							// ̔

}
//******************************
// Buzzer2 ON/OFF
//  on_off : 1=ON, 0=OFF
// *****************************
void	buz2_on_off(unsigned char on_off)
{
	if(on_off == 0){
		TCCR0B = 0;					// Timer0 Stop(Buzzer OFF)
		TCNT0 = 0;					// Timer0 Count Set to ZERO
	}else{
		TCCR0B = ( ( 1 << WGM02) | (1 << CS01) | (1 << CS00) );		// Timer Start (8MHz/64=125kHz)
	}
}
//******************************
// Buzzer2 ON/OFF Special
//  on_off : 1=ON, 0=OFF
//  syuki  : 1 -> 255
//			1=125kHz(8uS),
//			16=7.8kHz,
//			25=5kHz,
//			31=4kHz,
//			62=2kHz,
//			125=1kHz,
//			255=490Hz
//  eXgp֐
// *****************************
void	buz2_on_off_sp(unsigned char on_off, unsigned char syuki)
{
	if(on_off == 0){
		TCCR0B = 0;													// Timer0 Stop(Buzzer OFF)
		TCNT0 = 0;													// Timer0 Count Set to ZERO
	}else{
		OCR0A  = syuki;												// 250uS 8MHz/64=125kHz
		OCR0B  = syuki/2;											// ̔
		TCCR0B = ( ( 1 << WGM02) | (1 << CS01) | (1 << CS00) );		// Timer Start (8MHz/64=125kHz)
	}
}

